//加载并初始化模板对象
var appTemplate = loadTemplate("assets/templates/appitem.tpl");
var curChatTarget = null;
var appView = Backbone.View.extend({//options...
    initialize : function(option) {
        this.model.view = this;
        this.render();
    },
    template : appTemplate, //VIEW对应的模板
    render : function() {
        var self = this;
        this.$el = $(this.template({
                       data : this.model.attributes,
                       setState : this.setState
                   })); 

        this.bindingEvents();
        return this;
    },
    setState:function(state,type){
        var appState = '';
        if(type=="AppCanWgt"){
            if(parseInt(state)){
                appState ='<div class="appuinn uba crmxsjhb-9c uc-a1">'+
                '<div class="ulev-1 sxt-9c">打开</div>'+
                '</div>';
            }else{
                appState ='<div class="appuinn uba crmxsjhb-9c uc-a1">'+
                '<div class="ulev-1 "style="color:#2b61aa">下载</div>'+
                '</div>';
            }
        }
        return appState;
    },
    bindingEvents : function() {
        var self = this;
        appcan.button($(".scroll-bar", this.$el), "", function() {
            self.conver();
        })
        appcan.button($(".scroll-right", this.$el), "", function() {
            uexAppStoreMgr.cbDeleteMyApps = function(opId,dataType,data){
                //appcan.window.publish("YGET_APPLIST",'');
                self.model.set("state",0)
                var width = $(".scroll-right", this.$el).width();
                $(".scroll-bar", self.$el).css("-webkit-transform", "translateX(" + 0 + "px)");
            }
            var appinfo = [];
            var info = self.model.toJSON();
            appinfo.push(info);
            uexAppStoreMgr.deleteMyApps(JSON.stringify(appinfo));
        })
        $(this.$el).on("touchstart", function() {
            curChatTarget = self;
        })
    },
    swipeLeft : function() {
        if(this.isCanSwipe()){
            var width = $(".scroll-right", this.$el).width();
            $(".scroll-bar", this.$el).css("-webkit-transform", "translateX(-" + width + "px)");
        }
    },
    swipeRight : function() {
        if(this.isCanSwipe()){
            var width = $(".scroll-right", this.$el).width();
            $(".scroll-bar", this.$el).css("-webkit-transform", "translateX(" + 0 + "px)");
        }
    },
    isCanSwipe:function(){
        var state = this.model.get("state");
        var appCategory = this.model.get("appCategoryName") || this.model.get("appCategory");
        if((appCategory)=="AppCanWgt" && parseInt(state)==1){
            return true;
        }
        return false;
    },
    updateView : function(model) {
        var self = this;
        if(this.model.hasChanged("iconLoc")){
            var imgIcon = this.model.get("iconLoc");
            if(imgIcon){
                 $("div.lazy").data("original",  imgIcon)
                 $("div.lazy").lazyload({
                     cache : true
                 });
            }
        }
        
        if(this.model.hasChanged("name")){
            var name = this.model.get("name");
            $(".name",this.$el).html(name);
        }
        if(this.model.hasChanged("curVersion")){
            var curVersion = this.model.get("curVersion");
            $(".curVersion",this.$el).html(curVersion);
        }
        if(this.model.hasChanged("state")){
            var state = this.model.get("state");
            var appCategory = this.model.get("appCategoryName") || this.model.get("appCategory");
            $(".state",this.$el).html(this.setState(state,appCategory));
        }
        
    },
    conver : function() {
        var data = this.model.toJSON();
        if(!isDefine(data.serviceStatus) || data.serviceStatus==2){
            appcan.window.publish("START_WGT",JSON.stringify(data));
        }else{
            appcan.window.alert({
                title : "温馨提示",
                content : "您已经没有该权限，请查看您的服务状况，如有疑问请联系客服：400-040-1766",
                buttons : ['确定'],
                callback : function(err, data1, dataType, optId) {
                    
                }
            });
        }
        
    }
});

//列表容器VIEW
var appManageView = Backbone.View.extend({//options...

    initialize : function() {
        this.collection = new appCollection();
        this.listenTo(this.collection, "add", this.add);
        this.listenTo(this.collection, "change", this.updateView);
        this.listenTo(this.collection, "remove", this.removeView);
        this.showView();
    },
    el : '#applist ul', //VIEW 对应 HTML 元素CSS选择器
    load : function() {//HTML页面调用的初始化接口，由于通讯有可能依赖APPCAN组件，因此封装此接口在appcan.ready中调用
        var self = this;
        this.collection.fetch({
            success : function(cols, resp, options) {
                appcan.frame.resetBounce(0);
                $("div.lazy").lazyload({
                    cache:true
                });
                if (self.collection.length <= 0) {
                    $("#norecord").removeClass("uhide");
                } else {
                    $("#norecord").addClass("uhide");
                   // appcan.locStorage.setVal("CHATLIST_STORAGE",JSON.stringify(self.collection.toJSON()));
                }
            },
            error : function(cols, error, options) {
                appcan.frame.resetBounce(0);
            },
            add:true,
            remove:true,
            merge:true
        });
    },
    add : function(model) {
        try {
            var view = new appView({
                model : model
            });
            this.$el.append(view.$el);
        } catch(e) {
            alert(e.message+'--'+e.stack);
        }
    },
    updateView : function(model, a) {
        var view = model.view;
        if (view) {
            //this.$el.append(view.$el);
            view.updateView(model);
        }
    },
    removeView : function(model) {
        var view = model.view;
        view.remove();
    },
    showView : function(){
        var apps = appcan.getLocVal("CACHE_APPS_LIST") || '[]';
        if(apps!='[]')
        this.collection.set(JSON.parse(apps));
    }
});

var appManageViewInstance = new appManageView();

appcan.ready(function() {
    try{
        var param = {
            isSupport:true
        };
        uexWindow.setIsSupportSwipeCallback(JSON.stringify(param));
    }catch(e){}
    appcan.frame.setBounce([0], null, null, function(type) {
        if(type==0){//下拉刷新
            appManageViewInstance.load();
        }else{
            appcan.frame.resetBounce(type);
        }
        
    })
    setTimeout(function(){
        uexWindow.topBounceViewRefresh();
    },300)
    appcan.window.swipeLeft(function(){
        curChatTarget && curChatTarget.swipeLeft();
        curChatTarget = null;
    })
    appcan.window.swipeRight(function(){
        curChatTarget && curChatTarget.swipeRight();
        curChatTarget = null;
    })
    
})

