//加载并初始化模板对象
var chatTemplate = loadTemplate("assets/templates/chatitem.tpl");
var curChatTarget = null;
var deleteId = '';
var chatView = Backbone.View.extend({//options...
    initialize : function(option) {
        if (this.model.get("chatType") == 1){
            this.userModel = new userInfoModel({}, {
                    userId : this.model.get("imId")
                });
        }

        this.model.view = this;
        this.render();
        if (this.model.get("chatType") == 1){
            this.updateUserInfo();
            this.listenTo(this.userModel, "change", this.updateUserInfo);
        }
    },
    template : chatTemplate, //VIEW对应的模板
    render : function() {
        var self = this;

        this.$el = $(this.template({
            data : this.model.attributes,
            dateSet : self.dateSet,
            dealIconChat : self.dealIconChat,
            countSize : self.countSize,
            dealContent : self.dealContent
        }));
        this.bindingEvents();
        return this;
    },
    countSize : function(count){
        if (count && parseInt(count) >99 ){
            return '99+';
        }
        return count;
    },
    dealContent : function(cont){
        if(cont=='' || cont==null || !isDefine(cont)){
                    return ''
          }
        if(cont.indexOf("locationhttp")==0)
        return "[位置]";
        return cont;
    },
    dealIconChat : function(chatType){
        if (Number(chatType) == 1){
            return 'lazy';
        }
        return "";
    },
    bindingEvents : function() {
        var self = this;
        appcan.button($(".scroll-bar", this.$el), "", function() {
            self.conver();
        })
        appcan.button($(".scroll-right", this.$el), "", function() {
            var chatType = self.model.get("chatType");
            var imId = self.model.get("imId");
            deleteId = imId;
            if (parseInt(chatType) == 1) {//1 单聊
                var param = {
                    imId : imId.toLowerCase()
                }
                var params = JSON.stringify(param);
                uexIM.deleteUserChatRecord(params);
            } else {
                var param = {
                    groupName : imId
                }
                var params = JSON.stringify(param);
                uexIM.deleteChatGroupRecord(params);
            }

        })
        $(this.$el).on("touchstart", function() {
            curChatTarget = self;
        })
    },
    swipeLeft : function() {
        try{
            var width = $(".scroll-right", this.$el).width();
            $(".scroll-bar", this.$el).css("-webkit-transform", "translateX(-" + width + "px)");
        }catch(e){
            alert(e.message)
        }
    },
     swipeRight : function() {
            var width = $(".scroll-right", this.$el).width();
            $(".scroll-bar", this.$el).css("-webkit-transform", "translateX(" + 0 + "px)");
        },
    updateView : function(model) {
        var self = this;
        try{
        var chatType = Number(model.get("chatType"));
        var timestamp = (model.get("timestamp"));
        var content = (model.get("content"));
        var unreadCount = (model.get("unreadCount"));

        if (chatType == 2)
            $(".fullName", self.$el).html(model.get("groupDes"));
        else{
           $(".fullName", self.$el).html(self.userModel.get("fullName"));
        }
        $(".timestamp", self.$el).html(self.dateSet(timestamp));
        $(".content", self.$el).html(self.dealContent(content));
        var unreadDom = $(".unreadCount", self.$el);
        if(unreadCount && parseInt(unreadCount)>99){
            unreadCount = "99+";
        }
        unreadCount ? unreadDom.html(unreadCount).parent().removeClass("uhide") : unreadDom.parent().addClass("uhide");
        if(chatType==1){
            var icon = self.userModel.get("userIcon")
            if (icon) {
                $("div.lazy", self.$el).data("original", constant.IMG_URL + icon)
                console.log(icon)
                console.log(constant.IMG_URL + icon)
                 $("div.lazy", self.$el).lazyload({
                    cache : true,
                    callBack : function(path,s){
                        s.dom.css('background-image','url("' + path + '")');
                        if(s.dom.children().length>1)
                            s.dom.children().last().first().empty();
                    }
                 });
            }
        }
        }catch(e){
console.log(e)
        }
    },
    loadUserInfo : function() {
        var self = this;
        self.userModel.fetch({
            success : function(cols, resp, options) {
                self.updateUserInfo();
                //appcan.locStorage.setVal("CHAT_STORAGE"+self.model.get("imId"),JSON.stringify(self.userInfoModel.toJSON()));
            },
            error : function(cols, error, options) {
            },
            staffId : self.model.get("imId")
        });
    },
    updateUserInfo : function() {
        var self = this;
        try {

            if (this.model.get("chatType") == 1){
                self.setUserIcon();
                $(".fullName", self.$el).html(self.userModel.get("fullName"));
            }
        } catch(e) {
            //alert(e.message);
        }
    },
    setUserIcon : function() {
        try{
        var self = this;
        var icon = self.userModel.get("userIcon");
        console.log(icon)
        var fullName = self.userModel.get("fullName");
        //alert(constant.IMG_URL + icon)
        var lastNameStr = '';
        var lastName = fullName.substring((fullName.length)-1,fullName.length);
        var lastNameSP = shouPin.getCamelChars(lastName);
        lastNameStr = '<div style="text-align:center;color:#ffffff;">'+lastName+'</div>';
        $('div.lazy', self.$el).css("background-color",generateColor(lastNameSP));
        $('div.lazy', self.$el).children().last().first().html(lastNameStr);
        if (icon) {
            $("div.lazy", self.$el).data("original", constant.IMG_URL + icon)
            console.log(constant.IMG_URL + icon)
             $("div.lazy", self.$el).lazyload({
                cache : true,
                callBack : function(path,s){
                    s.dom.css('background-image','url("' + path + '")');
                    if(s.dom.children().length>1)
                        s.dom.children().last().first().empty();
                }
             });
        }
        }catch(e){
            console.log(e)
        }
    },
    conver : function() {
        try {
            var self = this;
            var chatType = Number(this.model.get("chatType"));
            if (chatType == 1) {//单聊
                var conName = (chatType == 1 ? this.userModel.get("fullName") : this.model.get("groupDes"));
                var lastMsg = this.model.get("content");
                var unreadDom = $(".unreadCount", this.$el);
                unreadDom.html("0").parent().addClass("uhide");
                var params = {
                    imId : this.model.get("imId").toLowerCase(),
                    type : "all"
                }
                var params1 = JSON.stringify(params);
                appcan.setLocVal("yghao", this.model.get("imId").toLowerCase());
                appcan.setLocVal("contactsName", conName);
                appcan.setLocVal("lastMsg", lastMsg);
                appcan.setLocVal("conImg", this.userModel.get("userIcon"));
                // window.alert(params1);
                uexWidget.startWidget("IM", "10", "", "huihuadanliao1.html", "300");
                uexIM.setMarkMsgRead(params1);
                //将某人的消息全部标为已读
                uexIM.getUserAndGroupAllMsgUnreadCount();
            } else {
                var groupDes = (chatType == 1 ? this.userModel.get("fullName") : this.model.get("groupDes"));
                var unreadDom = $(".unreadCount", this.$el);
                unreadDom.html("0").parent().addClass("uhide");
                var params = {
                    groupName : this.model.get("imId").toLowerCase(),
                    type : "all"
                }
                var params1 = JSON.stringify(params);
                appcan.setLocVal("groupObjIds", "");
                appcan.setLocVal("groupName", this.model.get("imId"));
                appcan.logs("groupName="+ this.model.get("imId"));
                appcan.setLocVal("groupDes", groupDes);
                uexWidget.startWidget("IM", "10", "", "huihuaqunliao.html", "300");
                uexIM.setMarkGroupMsgRead(params1);
                //将某人的消息全部标为已读
                uexIM.getUserAndGroupAllMsgUnreadCount();
            }
            self.swipeRight();
        } catch(e) {
            window.alert(e.message);
        }
    },
    dateSet : function(d) {
        var time = NYR(d, 1);
        var nyr = NYR('', 1);
        if (time == nyr) {
            var cTime = HM(d);
        } else {
            var cTime = NYR(d, 0);
        }
        return cTime;
    }
});

//列表容器VIEW
var chatListView = Backbone.View.extend({//options...

    initialize : function() {
        this.listenTo(this.collection, "add", this.add);
        this.listenTo(this.collection, 'sort', this.sort);
        this.listenTo(this.collection, "change", this.updateView);
        this.listenTo(this.collection, "remove", this.removeView);
    },
    collection : new chatCollection(), //collection，用于存储和管理数据
    el : '#chatlist ul', //VIEW 对应 HTML 元素CSS选择器
    load : function() {//HTML页面调用的初始化接口，由于通讯有可能依赖APPCAN组件，因此封装此接口在appcan.ready中调用
        var self = this;
        this.collection.fetch({
            success : function(cols, resp, options) {
                $('.fullName').each(function(index,item){
                    var curEle = $(item);
                    if(curEle.html=="　"){
                        self.collection.get($(item).data("imid")).view.loadUserInfo();
                    }
                })
                $("div.lazy").lazyload({
                    cache : true,
                    callBack : function(path,s){
                        s.dom.css('background-image','url("' + path + '")');
                        if(s.dom.children().length>1)
                        s.dom.children().last().first().empty();
                    }
                 });
                appcan.frame.resetBounce(0);
                if (self.collection.length <= 0) {
                    $("#norecord").removeClass("uhide");
                } else {
                    $("#norecord").addClass("uhide");
                   // appcan.locStorage.setVal("CHATLIST_STORAGE",JSON.stringify(self.collection.toJSON()));
                }
            },
            error : function(cols, error, options) {
                appcan.frame.resetBounce(0);
            },
            add:true,
            remove:true,
            merge:true
        });
    },
    add : function(model) {
        try {
            model.set("unreadCount", model.get("unreadCount") || 0);
            var view = new chatView({
                model : model
            });
            this.$el.prepend(view.$el);
            if (model.get("chatType") == 1)
                view.loadUserInfo();
        } catch(e) {
            alert(e.message);
        }
    },
    updateView : function(model, a) {
        var view = model.view;
        if (view) {
            if (model.hasChanged("content")) {
                this.$el.prepend(view.$el);
            }
            view.updateView(model);
        }
    },
    sort : function() {
        //按照collection中的数据顺序，变更model相关view在listview中的排序
        for (var i = 0; i < this.collection.length; i++) {
            var model = this.collection.models[i];
            if (model.view) {
                this.$el.prepend(model.view.$el);
            }
        }
    },
    removeView : function(model) {
        var view = model.view;
        view.remove();
    }
});

var chatListViewInstance = new chatListView();

appcan.ready(function() {
    try{
        var param = {
            isSupport:true
        };
        uexWindow.setIsSupportSwipeCallback(JSON.stringify(param));
    }catch(e){}
    appcan.window.subscribe("CB_DEL_RECORD", function(result) {
        if (result == 1) {
            appcan.window.openToast("删除成功", 1500, 5);
            uexIM.getUserAndGroupAllMsgUnreadCount();
            if(deleteId){
                var col = chatListViewInstance.collection;
                col.remove(col.get(deleteId));
                deleteId = '';
            }
        } else {
            appcan.window.openToast("网络错误", 1500, 5);
        }
    });
    // appcan.window.subscribe("CB_ALL_UNREAD_COUNT", function(result) {
        // //var data = JSON.parse(result);
        // var data = result;
        // var ucount = data.unreadCount;
        // appcan.window.publish("ucount", ucount);
    // });
    appcan.window.subscribe("E_XMPP_ZUMSG", function(aa) {
        appcan.logs("群组监听到新消息开始刷新");
        chatListViewInstance.load();
    });
    appcan.window.subscribe("E_XMPP_NEWMSG", function(list) {
        appcan.logs("9999999新消息开始刷新");
        chatListViewInstance.load();
    });
    appcan.window.subscribe("E_XMPP_SHUXINMSG", function(list) {
        appcan.logs("66666新消息开始刷新");
        chatListViewInstance.load();
    });
    appcan.window.subscribe("E_XMPP_NEWMSGCOMING", function(param) {
        appcan.logs("什么什么进来了");
        chatListViewInstance.load();
    })
    appcan.window.subscribe("CB_LEAVE_CHATGROUP", function(result) {
        chatListViewInstance.load();
    });
    appcan.window.swipeLeft(function(){
        curChatTarget && curChatTarget.swipeLeft();
        curChatTarget = null;
    })
    appcan.window.swipeRight(function(){
        curChatTarget && curChatTarget.swipeRight();
        curChatTarget = null;
    })
    appcan.window.subscribe("E_XMPP_LOGIN_RES", function(result) {
        if (result == 0) {
            chatListViewInstance.load();
        }
    })
})

