//加载并初始化模板对象
var contactItemTemplate = loadTemplate("assets/templates/contactItem_content.tpl");
var contactView = Backbone.View.extend({//options...
    initialize : function(option) {
        //初始化VIEW并让model与VIEW进行关联
        this.model.view = this;
        //初始化VIEW的HTMLDOM对象
        this.render();
        var userId = this.model.get("userId");
        if(userId){
            this.model.on("change",function(){
                appcan.setLocVal("CACHE_USERINFO_"+userId.toUpperCase(),JSON.stringify(this.toJSON()))
            })
            appcan.setLocVal("CACHE_USERINFO_"+userId.toUpperCase(),JSON.stringify(this.model.toJSON()))
        }
         
    },
    template : contactItemTemplate,
    render : function() {
        var self = this;
        if (self.template) {
            var name = self.model.attributes.fullName;
            var lastName = name.substr((name.length)-1,1);
            var lastNameSP = shouPin.getCamelChars(lastName);
            //使用模板+数据拼装DOM
            self.$el = $(self.template({
                data : self.model.attributes,
                isMobile : function(mobile) {
                    if (isDefine(mobile)) {
                        return "bm-phone";
                    }
                    return "";
                },
                setIcon : function(icon) {
                    if (icon)
                        return 'lazy" data-original="' + constant.IMG_URL + icon+'" style="background-color:'+generateColor(lastNameSP);
                    return ' lazy" style="background-color:'+generateColor(lastNameSP);
                },
                setIconFont : function(icon){
                    var lastNameStr = '<div style="line-height:2.5em; text-align:center;color:#ffffff;">'+lastName+'</div>';
                    return lastNameStr;
                }
            }));
            self.bindingEvent(self.model);
        }
        //返回自身，便于promise调用
        return self;
    },
    bindingEvent : function(model) {
        var self = this;
        appcan.button($(".bm-phone", self.$el), "btn-act", function() {
            var telnum = model.get("mobileNo");
            uexCall.dial(telnum);
        })
        appcan.button($(".bm-xxduihua", self.$el), "btn-act", function() {
            var userId = model.get("userId");
            var userIcon = model.get("userIcon");
            var sonName = model.get("fullName");
            appcan.setLocVal(storeKey.PERSON_ID, userId);
            appcan.setLocVal(storeKey.CONTACT_ICON, userIcon);
            appcan.setLocVal(storeKey.CONTACT_NAME, sonName);
            uexWidget.startWidget("IM", "10", "", "huihuadanliao1.html", "300");
        })
        appcan.button($(".del", self.$el), "btn-act", function() {
            var userId = model.get("userId");
            var conName = model.get("fullName");
            appcan.setLocVal(storeKey.PERSON_NAME, conName);
            appcan.setLocVal(storeKey.CONTACT_NAME, conName);
            appcan.setLocVal(storeKey.PERSON_ID, userId);
            if(isAndroid){
                appcan.window.open('contactsMain', 'contactsMain.html', "10",64);
            }else{
                appcan.window.open('contactsMain', 'contactsMain.html', "10");
            }
            
        })
    },
    updateView : function(model) {
        var self = this;
        var imgIcon = '';
        if (model.hasChanged("userIcon")) {
            imgIcon = model.get("userIcon");
            if (imgIcon) {
                $("div.lazy", self.$el).data("original", constant.IMG_URL + imgIcon)
                $("div.lazy").lazyload({
                    cache : true,
                    callBack : function(path,s){
                        s.dom.css('background-image','url("' + path + '")');
                        s.dom.empty();
                    }
                });
            }
        }
        if (model.hasChanged("fullName"))
            $(".ygnme", this.$el).html(model.get("fullName"));
        if (model.hasChanged("roleName"))
            $(".roleName", this.$el).html(model.get("roleName"));
        if (this.model.hasChanged("mobileNo")) {
            var phone = model.get("mobileNo");
            if (isDefine(phone)) {
                $(".bm-phonewh", this.$el).addClass("bm-phone")
            } else {
                $(".bm-phonewh", this.$el).removeClass("bm-phone")
            }

        };
    },
    dateSet : function(d) {
        var time = NYR(d, 1);
        var nyr = NYR('', 1);
        if (time == nyr) {
            var cTime = HM(d);
        } else {
            var cTime = NYR(d, 0);
        }
        return cTime;
    }
});

//列表容器VIEW
var contactListView = Backbone.View.extend({//options...

    initialize : function() {
        //初始化集合与VIEW自身函数的关联
        this.listenTo(this.collection, "add", this.addView);
        this.listenTo(this.collection, "change", this.updateView);
        this.listenTo(this.collection, "remove", this.removeView);
        //初始化服务与VIEW自身函数的关联
        //this.viewCollection=this.collection;
    },
    collection : new contactCollection(), //collection，用于存储和管理数据
    el : '#contactlist ul', //VIEW 对应 HTML 元素CSS选择器
    pageNo : 1,
    load : function(flag) {//HTML页面调用的初始化接口，由于通讯有可能依赖APPCAN组件，因此封装此接口在appcan.ready中调用
        //appcan.window.openToast("正在加载");
        var indexInfo = JSON.parse(appcan.getLocVal("EMM_USER_INFO"));
        var dptId = indexInfo.loginUser.entity.department[0].dptId;
        this.collection.fetch({
            flag : flag?flag:0,//是否刷新数据
            dptId : dptId,
            success : function(cols, resp, options) {
                appcan.window.closeToast();
                appcan.frame.resetBounce(0);
                $("div.lazy").lazyload({
                    cache : true,
                    callBack : function(path,s){
                        s.dom.css('background-image','url("' + path + '")');
                        s.dom.empty();
                    }
                });
                try {
                    if (cols.length <= 0) {
                        $("#norecord").removeClass("uhide");
                    } else {
                        self.pageNo++;
                        $("#norecord").addClass("uhide");
                    }
                } catch(e) {
                    ALERT_ERROR("contactListView", "load", e.message);
                }
            },
            error : function(cols, error, options) {
                appcan.window.closeToast();
                appcan.frame.resetBounce(0);
                switch(error.status) {
                // case "a01":
                // break;
                default:
                    global_error(error);
                    break;
                }
            },
            add : true,
            remove : true,
            merge : true
        });
    },
    searchPer : function() {
        appcan.window.openToast("正在加载");
        var fullName = $("#my_form").val();
        this.collection.fetch({
            fullName : fullName,
            success : function(cols, resp, options) {
                appcan.window.closeToast();
                appcan.frame.resetBounce(0);
                $("div.lazy").lazyload({
                    cache : true,
                    callBack : function(path,s){
                        s.dom.css('background-image','url("' + path + '")');
                        s.dom.empty();
                    }
                });
                try {
                    if (cols.length <= 0) {
                        $("#norecord").removeClass("uhide");
                    } else {
                        self.pageNo++;
                        $("#norecord").addClass("uhide");
                    }
                } catch(e) {
                    ALERT_ERROR("contactListView", "load", e.message);
                }
            },
            error : function(cols, error, options) {
                appcan.window.closeToast();
                appcan.frame.resetBounce(0);
                switch(error.status) {
                // case "a01":
                // break;
                default:
                    global_error(error);
                    break;
                }
            },
            add : true,
            remove : true,
            merge : true
        });
    },
    addView : function(model) {
        //collection中每加入一条数据都会被调用，用于创建新的商品view
        var view = new contactView({
            model : model
        });
        //把条目view的dom对象插入到listview DOM对象中
        this.$el.append(view.$el);
    },
    updateView : function(model) {
        var view = model.view;
        if (view) {
            // this.$el.prepend(view.$el);
            view.updateView(model);
        }
    },
    removeView : function(model) {
        var view = model.view;
        view.remove();
    }
});

var contactListViewInstance = new contactListView();

appcan.button("#remove", "ani-act ", function() {
    //取消XX按钮
    $("#remove").addClass("uhide-serach");
    $("#my_form").val("");
    contactListViewInstance.load();
})
appcan.button("#gsbumen", "ani-act ", function() {
    appcan.setLocVal("branchOrDptId", "0");
    uexWidget.startWidget('EMCONTACT', '10', '', 'contactDpt.html', '250');
})
// appcan.button("#searchH", "ani-act ", function() {
    // uexWidget.startWidget('EMCONTACT', '10', '', 'contactPerson.html', '250');
// })
appcan.button("#qunzulist ", "ani-act ", function() {
    appcan.window.open('qunzuliebiao', 'chat/qunzuliebiao.html', '10');
})
function selectWho() {//根据条件来查询
    contactListViewInstance.searchPer();
}

function OnInput() {
    var search_text = $("#my_form").val();
    if (search_text != "" || search_text.length != 0) {
        $("#remove").removeClass("uhide-serach");
    } else {
        $("#remove").addClass("uhide-serach");
        $("#my_form").val("");
    }
}