var personInfoView = Backbone.View.extend({//options...
    initialize : function() {
        try{
            var staffId = appcan.getLocVal("userIdIm");
            this.model = new userInfoModel({}, {
                        userId : staffId
                    });
            this.updateData();
            this.listenTo(this.model, "change", this.updateData);
            this.stickit();
        }catch(e){
        }
    },
    //model:new userInfoModel(),
    el : '#userInfo',
    bindings : {
        "#tel" : "teleNo",
        "#phone" : "mobileNo",
        "#email" : "email",
        "#userSex" : "userSex"
    },
    sexSet : function(type) {
        var sexType = {"male":"男","female":"女"};
        return sexType[type];
    },
    modelSet:function(){
        // var info = appcan.getLocVal(storeKey.PERSON_INFO);
        // if(info) {
            // info = JSON.parse(info);
            // info.userSex = info.sexId=="02"?"female":"male";
            // $('#sexN').html(this.sexSet(info.userSex));
            // info.uniqueField = info.userId;
            // info.userIcon = info.userIcon;
            // this.model.set(info);
        // }
        this.bindingEvents();
    },
    updateData : function(){
        var  info = this.model.toJSON();
        var imgIcon = info.userIcon;
        var fullName = info.fullName;
        var lastNameStr = '';
        var lastName = fullName.substring((fullName.length)-1,fullName.length);
        var lastNameSP = shouPin.getCamelChars(lastName);
        lastNameStr = '<div style="font-size:1.5em;text-align:center;color:#ffffff;">'+lastName+'</div>';
        $('div.lazy').css("background-color",generateColor(lastNameSP));
        var img = $("div.lazy").css("background-image");
        if(!img||img == 'none')
        $('div.lazy').html(lastNameStr);
        if(imgIcon){
            $("div.lazy").data("original", constant.IMG_URL + imgIcon)
            appcan.ready(function(){
                $("div.lazy").lazyload({
                     cache : true,
                    callBack : function(path,s){
                        s.dom.css('background-image','url("' + path + '")');
                        s.dom.empty();
                    }
                 });
            })

        }
        info.userSex = info.sexId=="02"?"female":"male";
        this.model.set({"userSex":info.userSex},{silent: true})
        this.model.set({"email":($.trim(info.email))},{silent: true});
        $('#userSex').val(info.userSex);
        $('#sexN').html(this.sexSet(info.userSex));
    },
    bindingEvents : function(){
        var self = this;
        appcan.button("#imgurl","btn-act",function(){
            uexWindow.cbActionSheet = function(a, b, data) {
                switch(parseInt(data)) {
                case 0:
                    self.getCam();
                    break;
                case 1:
                    self.selPic();
                    break;
                }
            }
            var str = ["拍照", "相册"];
            uexWindow.actionSheet("菜单", "取消", str);
        })
    },
    getCam : function(){
        var self = this;
        uexCamera.cbOpen = function(opId, dataType, data) {
            if (dataType == 0) {
                var param = {
                    src:data
                }
                param=JSON.stringify(param);
                uexImage.openCropper(param);
                uexImage.onCropperClosed=function(info){
                    info = JSON.parse(info);
                    self.addPic(info.data);
                }
            }
        }
        uexCamera.open(0, 50);
    },selPic : function(){
        var self = this;
        uexImage.onPickerClosed = function(data) {
            data = JSON.parse(data);
            if(data.isCancelled == false){
                var param={
                    src:data.data[0]
                }
                param=JSON.stringify(param);
                uexImage.openCropper(param);
                uexImage.onCropperClosed=function(info){
                    info = JSON.parse(info);
                    self.addPic(info.data);
                }
            }
            self.showBar();
        }

        var sData = {
            min:1,
            max:1
        }
        var json = JSON.stringify(sData);
        uexImage.openPicker(json);
    },
    picNum:0,
    addPic : function (data){
        if(data){
            var self = this;
            this.picNum ++;
            $("#imgurl").css("background-image","url('"+data+'?'+this.picNum+"')!important").empty();;
            if(isSaas){
                uploadFileEMM(data,function(serverUrl){
                    self.model.set({"userIcon":serverUrl},{silent: true});
                });
            }else{
                uploadFile(data,function(serverUrl){
                    self.model.set({"userIcon":serverUrl},{silent: true});
                });
            }

        }
        this.showBar();
    },showBar : function(){
        if(uexWindow.showStatusBar) uexWindow.showStatusBar();
    },
    submitInfo : function() {
        var self = this;
        //$("#userIcon").val(serverUrl);
        if (!this.model.isValid()) {
            appcan.window.openToast(this.model.validationError, 1500, 5);
            return false;
        }

        appcan.window.openToast("正在提交");
        var userSex = $('#userSex').val();
        var sexId = userSex=='female'?"02":"01";
        this.model.set({"userSex":$('#userSex').val()},{silent: true})
        this.model.set({"sexId":sexId},{silent: true});
        this.model.save({}, {
            success : function(model, resp, options) {
                appcan.setLocVal("CACHE_USERINFO_"+self.model.get("userId").toUpperCase(),JSON.stringify(self.model.toJSON()));
                appcan.setLocVal(storeKey.PERSON_INFO, JSON.stringify(self.model.toJSON()));
                appcan.window.closeToast();
                appcan.setLocVal(storeKey.PERSON_INFO_ICON, self.model.get("userIcon"));
                appcan.window.openToast("资料更新成功", 1500, 5);
                appcan.window.publish("PERSONINFO_EDIT", "PERSONINFO_EDIT");
            },
            error : function(model, error, options) {
                appcan.window.closeToast();
                switch(error.status)
                {
                     case "000":

                     break;
                    default:
                    global_error(error);
                    break;
                }
            }
        });
        return false;
    }
});
var personInfoViewInstance = new personInfoView();
function submitInfo(){
    personInfoViewInstance.submitInfo();
}
appcan.select(".select",function(ele,value){
    console.log(value);
});
