//加载并初始化模板对象
var templateHTML = loadTemplate("../assets/templates/remindList.tpl");

var remindView = Backbone.View.extend({//options...
    initialize : function(option) {
        //初始化VIEW并让model与VIEW进行关联
        this.model.view = this;
        //初始化VIEW的HTMLDOM对象
        this.render();
    },
    template : templateHTML, //VIEW对应的模板
    render : function() {
        var self = this;
        if (this.template) {
            //使用模板+数据拼装DOM
            this.$el=$(this.template({
                data:this.model.attributes,
                dateSet:self.dateSet,
                setStatus : self.setStatus,
                titstatus : self.titstatus,
                iconSet : self.iconSet
            })); 
            
            //为DOM增加点击效果
            appcan.button(this.$el,"btn-act",function(){
                var entity = self.model.toJSON().entity;
                var entityTypeId = entity.objEntityTypeId;
                var objectId = entity.objObjectId;
                var appId = self.model.get("appId")
                switch(entityTypeId){
                    case "09"://公告
                    appcan.setLocVal('NOTICE-ID',objectId);
                    //appcan.window.open("notice_detail","notice_detail.html",10);
                    info = {appId:appId,param:{"name":"notice_detail","data":"notice_detail.html?noticeId="+objectId}}
                    break;
                    case "24"://工单
                    appcan.setLocVal('WORKFLOW-STATE',"已退回");
                    appcan.setLocVal('WORKFLOW-TITLE',entity.title);
                    var obj = entity.workFlowInfo;
                    obj.busiName = entity.title.split(" ")[1];
                    obj.businessKey = objectId;
                    obj.tenantId = remindListViewInstance.tenantId;
                    obj.busiid = obj.billKey;
                    console.log(JSON.stringify(obj))
                    //return;
                    appcan.setLocVal('WORKFLOW-DATA',JSON.stringify(obj));
                    info = {appId:appId,param:{"name":"workFlow_detail","data":"workFlow_detail.html?closeWgt=1"}}
                    //appcan.window.open("workFlow_detail","workFlow_detail.html",10);
                    break;
                    case "26"://计划
                    appcan.setLocVal('PLAN-ID', objectId);
                    appcan.setLocVal("PLAN-FROM-OPEN","");
                    info = {appId:appId,param:{"name":"dptPlan_detail","data":"dptPlan_detail.html?closeWgt=1"}}
                    //appcan.window.open("aptPlan_detail","aptPlan_detail.html",10);
                    break;
                    default://先放线索在这里
                    break;
                    
                }
                appcan.window.publish("EPORTAL_LOAD_APP",JSON.stringify(info));
                remindListViewInstance.remindread(self.model.get("objectId"));
            })
        }
        //返回自身，便于promise调用
        return this;
    },
    dateSet : function(d) {
        var d = (d+'').replace(/-/g,'/');
        var time = NYR(d, 1);
        var nyr = NYR('', 1);
        if (time == nyr) {
            var cTime = HM(d);
        } else {
            var cTime = NYR(d, 0);
        }
        return cTime;
    },
    setStatus:function(s){
        if(s){
            return '<div class="baseColor1">已读</div>'
        }else{
            return '<div class="baseColor2">未读</div>'
        }
    },
    titstatus : function(title,objEntityTypeId){
        if(objEntityTypeId == '24'){
            return title+'-审批退回';
        }else if(objEntityTypeId == '26'){
            return title+'-评阅退回';
        }else{
            return title;
        }
    },
    updateView:function(model){
        $(".readStatus",this.$el).html(this.setStatus(model.toJSON().entity.read))
        $(".remindTitle",this.$el).html(this.titstatus(model.toJSON().entity.title,model.toJSON().entity.objEntityTypeId));
    },
    iconSet:function(entityType){
        var icon = "";
        switch(entityType){
            case "09"://公告
            icon = "remindNotice";
            break;
            case "24"://工单
            icon = "remindFlowicon";
            break;
            case "26"://计划
            icon = "remindPlan";
            break;
            default:
            icon = "defaultIcon";
            break;
        }
        return icon;
    }
});

//列表容器VIEW
var remindListView = Backbone.View.extend({//options...
    initialize : function() {
        var self = this;
        //初始化集合与VIEW自身函数的关联
        this.listenTo(this.collection, "add", this.addView);
        this.listenTo(this.collection, "change", this.updateView);
        this.listenTo(this.collection, "remove", this.removeView);
        this.listenTo(this.service, "fresh", function(data){
            if(!data.objectId){
                $(".readStatus").html('<div class="baseColor1">已读</div>')
            }else{
                var model = self.collection.get(data.objectId);
                model.attributes.entity.read = true;
                model.view.updateView(model)
                //model.set("entity.read",true);
            }
        });
    },
    service:requestService,
    collection : new remindCollection(), //collection，用于存储和管理数据
    el : '#remindList ul', //VIEW 对应 HTML 元素CSS选择器
    pageNo:1,
    load : function(type) {
        var self = this;
        if(type == 0){
            self.pageNo = 1;
        }
        var data= {
                    "ifno" : "zywx-message-0003",
                    "condition" : {
                        "pageNo" : self.pageNo,
                        "rowCnt" : 10
                    },
                    "content" : {
                        "entityTypeId":27
                    }
                }
        this.collection.fetch({
            params : {
                data : data
            },
            success : function(cols, resp, options) {
                try {
                    
                    if(type == 0){
                        if (cols.length <= 0) {
                            $("#norecord").removeClass("uhide");
                        } else {
                            self.pageNo++;
                            $("#norecord").addClass("uhide");
                        }
                    }else{
                        if (resp.msg.list.length <= 0) {
                            appcan.window.openToast("暂无更多的数据",1500,5);
                        }else{
                            self.pageNo++;
                        }
                    }
                    setTimeout(function(){
                        appcan.frame.resetBounce(type);
                    },100)
                    
                } catch(e) {
                    ALERT_ERROR("remindListView", "load", e.message);
                }
            },
            error : function(cols, error, options) {
                appcan.frame.resetBounce(type);
                switch(error.status) {
                default:
                    global_error(error);
                    break;
                }
            },
            add : true,
            remove : (type == 0) ? true : false,
            merge :  true
        });
    },
    addView : function(model) {
        var view = new remindView({
            model : model
        });
        this.$el.append(view.$el);
    },
    updateView : function(model) {
        var view = model.view;
        if (view) {
            //this.$el.prepend(view.$el);
            view.updateView(model);
        }
    },
    removeView:function(model){
        var view = model.view;
        view.remove();
    },remindread:function(objectId){
        var obj = {
            param:{
                "ifno": "zywx-message-0008",
                "condition": {},
                "content": {
                    "entityTypeId": "27"
                }
            }
        }
        if(objectId){
            obj.param.ifno = "zywx-message-0007";
            obj.param.content.objectId = objectId;
        }
        this.service.readRequest(obj);
    }
});
var remindListViewInstance = new remindListView();
var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
remindListViewInstance.tenantId = emmToken.info.tenantId || "611";