//加载并初始化模板对象
var templateHTML = loadTemplate("../assets/templates/todealList.tpl");

var todealView = Backbone.View.extend({//options...
    initialize : function(option) {
        //初始化VIEW并让model与VIEW进行关联
        this.model.view = this;
        //初始化VIEW的HTMLDOM对象
        this.render();
    },
    template : templateHTML, //VIEW对应的模板
    render : function() {
        var self = this;
        if (this.template) {
            //使用模板+数据拼装DOM
            this.$el=$(this.template({
                data:this.model.attributes,
                setIcon:self.setIcon,
                dateSet:self.dateSet
            })); 
            
            //为DOM增加点击效果
            appcan.button(this.$el,"btn-act",function(){
                var entityTypeId = self.model.get("entityTypeId");
                var objectId = self.model.get("objectId");
                var appId = self.model.get("appId");
                switch(entityTypeId){
                    case "24"://工单
                    appcan.setLocVal('WORKFLOW-STATE',"待办理");
                    var title = self.model.get("title");
                    appcan.setLocVal('WORKFLOW-TITLE',title);
                    var obj = self.model.toJSON();
                    obj.busiName = obj.name;
                    obj.businessKey = obj.objectId;
                    obj.tenantId = todealListViewInstance.tenantId;
                    obj.busiid = obj.billKey;
                    appcan.setLocVal('WORKFLOW-DATA',JSON.stringify(obj));
                    info = {appId:appId,param:{"name":"workFlow_detail","data":"workFlow_detail.html?closeWgt=1"}}
                    //appcan.window.open("workFlow_detail","workFlow_detail.html",10);
                    break;
                    case "26"://计划
                    appcan.setLocVal('PLAN-ID', objectId);
                    appcan.setLocVal("PLAN-FROM-OPEN","待审核");
                    info = {appId:appId,param:{"name":"dptPlan_detail","data":"dptPlan_detail.html?planId="+objectId}}
                    //appcan.window.open("aptPlan_detail","aptPlan_detail.html",10);
                    break;
                    default://先放线索在这里
                    break;
                    
                }
                appcan.window.publish("EPORTAL_LOAD_APP",JSON.stringify(info));
                //appcan.setLocVal('RULE-ID',self.model.id);
                //appcan.window.open("rule_detail","rule_detail.html",10);
            })
        }
        //返回自身，便于promise调用
        return this;
    },setIcon:function(entityTypeId){
        var className = '';
        switch(entityTypeId){
            case "24"://工单
            className = "toApprove";
            break;
            case "26"://计划
            className = "toReview";
            break;
            default://先放线索在这里
            className = "";
            break;
            
        }
        return className;
    },
    dateSet : function(d) {
        var d = (d+'').replace(/-/g,'/');
        var time = NYR(d, 1);
        var nyr = NYR('', 1);
        if (time == nyr) {
            var cTime = HM(d);
        } else {
            var cTime = NYR(d, 0);
        }
        return cTime;
    }
});

//列表容器VIEW
var todealListView = Backbone.View.extend({//options...
    initialize : function() {
        //初始化集合与VIEW自身函数的关联
        this.listenTo(this.collection, "add", this.addView);
        this.listenTo(this.collection, "change", this.updateView);
        this.listenTo(this.collection, "remove", this.removeView);
    },
    collection : new todealCollection(), //collection，用于存储和管理数据
    el : '#toDealList ul', //VIEW 对应 HTML 元素CSS选择器
    pageNo:1,
    load : function(type) {
        var self = this;
        if(type == 0){
            self.pageNo = 1;
        }
        var data= {
                    "ifno" : "zywx-message-0002",
                    "condition" : {
                        "pageNo" : self.pageNo,
                        "rowCnt" : 10
                    },
                    "content" : {
                    }
                }
        this.collection.fetch({
            params : {
                data : data
            },
            success : function(cols, resp, options) {
                try {
                    appcan.frame.resetBounce(type);
                    if(type == 0){
                        if (cols.length <= 0) {
                            $("#norecord").removeClass("uhide");
                        } else {
                            self.pageNo++;
                            $("#norecord").addClass("uhide");
                        }
                    }else{
                        if (resp.msg.list.length <= 0) {
                            appcan.window.openToast("暂无更多的数据",1500,5);
                        }else{
                            self.pageNo++;
                        }
                    }
                } catch(e) {
                    ALERT_ERROR("todealListView", "load", e.message);
                }
            },
            error : function(cols, error, options) {
                appcan.frame.resetBounce(type);
                switch(error.status) {
                default:
                    global_error(error);
                    break;
                }
            },
            add : true,
            remove : (type == 0) ? true : false,
            merge : (type == 0) ? false : true
        });
    },
    addView : function(model) {
        var view = new todealView({
            model : model
        });
        this.$el.append(view.$el);
    },
    updateView : function(model) {
        var view = model.view;
        if (view) {
            this.$el.prepend(view.$el);
            view.updateView(model);
        }
    },
    removeView:function(model){
        var view = model.view;
        view.remove();
    }
});
var todealListViewInstance = new todealListView();
var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
todealListViewInstance.tenantId = emmToken.info.tenantId || "611";
appcan.ready(function() {
     appcan.window.subscribe("EPORTAL_TODOLIST_READ_UPDATE",function(result){
         var collect = todealListViewInstance.collection;
         if(result)
        collect.remove(collect.get(result));
     })
})