function getHeaders(){
    var curTime = Date.now();
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var tenantId = emmToken.info.tenantId || "";
    var headerParam = {
        "x-mas-app-id" : appId,
        "accessToken":accessToken
    }
    if(tenantId){
        headerParam.tenantId = tenantId+'';
    }
    return headerParam;
}
function dptAndPer(dptId,callback){
    var msgObj = {
        status:"000",
        msg:{
            danPersonnel:{
                list:[]
            },
            personnel:{
                list:[]
            }
        }
    }
    var flag = 0;
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var indexInfo = JSON.parse(appcan.getLocVal("EMM_USER_INFO"));
    var dptIds = indexInfo.loginUser.entity.department[0].dptId;
    var brcId = indexInfo.loginUser.entity.brcId;
    var url =contactUrl+'danPersonnel?accessToken='+accessToken+'&orgId='+dptId+'&domainName='+encodeURIComponent(domainName);
    appcan.request.ajax({
        url :url,
        type : 'GET',
        headers : getHeaders(),
        contentType : 'application/x-www-form-urlencoded',
        timeout : "30000",
        data : {},
        offline : true,
        offlineDataPath : 'box://icache/',
        success : function(data, status, xhr) {
            var data = JSON.parse(data)
            var dptArr = [];
            for(var i=0;i<data.length;i++){
                var id = data[i].id;
                var name = data[i].name;
                var pId = data[i].pId;//父级id
                var dptObj = {
                    entityId:id,
                    dptName:name,
                    superDptId:pId
                }
                dptArr.push(dptObj);
            }
            msgObj.msg.danPersonnel.list= dptArr;
            if(flag == 0){
                flag = 1;
            }else{
                callback(null,msgObj);
            } 
        },
        error : function(data) {
            callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        }
    });
        var dptIdCur = dptId;
        if(brcId == dptId){
		if(isSaas){
	            if(dptIds!=dptIdCur)
	            {dptIdCur = dptIds+','+dptIdCur;}
	            else{
	                dptIdCur = dptIds
	            }
		}else{
		    dptIdCur = dptIds;
		}
        }
        var personUrl = contactUrl+'getPersonnelByOrgId?accessToken='+accessToken+'&orgId='+dptIdCur+'&domainName='+encodeURIComponent(domainName);
        appcan.request.ajax({
        url : personUrl,
        type : 'GET',
        headers : getHeaders(),
        offline : true,
        offlineDataPath : 'box://icache/',
        contentType : 'application/x-www-form-urlencoded',
        timeout : "30000",
        data : {},
        success : function(data, status, xhr) {
            var data = JSON.parse(data)
            var dptPerArr = []; 
            for(var j = 0;j<data.length;j++){
                var orgName = data[j].orgName;//brcName/dptName
                var dptName = "";
                if(orgName){
                   var orgNames = orgName.split(",");
                   var orgNameArr = orgNames[0].split("/");
                   var brcName = orgNameArr[0];//机构名称
                   dptName = orgNameArr[orgNameArr.length - 1]; //部门名称
                }
                var personnelId = data[j].personnelId;//id
                var uniqueField = data[j].uniqueField;//userId
                var name = data[j].name;//fullName
                var userSex = data[j].userSex;//sexId
                if(userSex == "male"){
                   var userSex = "01"; 
                }else if(userSex == "female"){
                    var userSex = "02";
                }
                var mobileNo = data[j].mobileNo?data[j].mobileNo:"";//mobileNo手机号
                var email = data[j].email?data[j].email:"";//email邮箱
                var loginName = data[j].loginName;//loginName登陆姓名
                var officePhone = data[j].officePhone;//teleNo办公电话
        		if(isSaas){
        		    var avatorLoc = data[j].avatorLoc
        		}else{
                    var avatorLoc0 = data[j].avatorLoc.split("/");//userIcon
                    var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
        		}
                var jobId = data[j].jobId;//roleId
                var jobName = data[j].jobName;//roleName
                var jobName1 = "";
                if(jobName){
                    var jobArr = jobName.split(",");
                    jobName1 = jobArr[0];
                }
                var topOrgIds = data[j].topOrgIds;//brcId
                var orgIds = data[j].orgIds;//dptId
                var higherLevelUniqueField = data[j].higherLevelUniqueField;//ldrUserId
                var higherLevelName = data[j].higherLevelName;//ldrFullName
                var leadname = "";
                if(higherLevelName){
                    leadname = higherLevelName.split(",")[0];
                }
                var positionTypeId = data[j].positionTypeId;//positionTypeId
                var positionTypeName = data[j].positionTypeName;
                var dptPerObj = {
                    userId : uniqueField,
                    fullName : name,
                    sexId : userSex,
                    mobileNo : mobileNo,
                    email : email,
                    loginName : loginName,
                    teleNo : officePhone,
                    userIcon : avatorLoc,
                    roleId : jobId,
                    roleName : jobName1,
                    brcId : topOrgIds,
                    dptId : orgIds,
                    brcName : brcName,
                    dptName : dptName,
                    ldrUserId : higherLevelUniqueField,
                    ldrFullName : leadname,
                    positionTypeId : positionTypeId,
                    positionTypeName : positionTypeName
                }
                dptPerArr.push(dptPerObj);
            }
            msgObj.msg.personnel.list = dptPerArr;
            if(flag == 0){
                flag = 1;
            }else{
                callback(null,msgObj);
            }
        },
        error : function(data) {
            callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        }
    });
  
}
function personInfoEmm(staffId,callback){
    var msgObj = {
        msg:{
            item:{
                userId:"",
                entity:{}
            }
        }
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    appcan.request.ajax({
    url : contactUrl+'getByUniqueField?accessToken='+accessToken+'&uniqueField='+staffId+'&domainName='+encodeURIComponent(domainName),
    type : 'GET',
    headers : getHeaders(),
    contentType : 'application/x-www-form-urlencoded',
    timeout : "30000",
    data : {},
    success : function(data, status, xhr) {
        var data = JSON.parse(data);
        if(data[0]){
            var j = 0;
            var orgName = data[j].orgName;//brcName/dptName
            var dptName = "";
            if(orgName){
               var orgNames = orgName.split(",");
               var orgNameArr = orgNames[0].split("/");
               var brcName = orgNameArr[0];//机构名称
               dptName = orgNameArr[orgNameArr.length - 1]; //部门名称
            }
            var personnelId = data[j].personnelId;//id
            var uniqueField = data[j].uniqueField;//userId
            var name = data[j].name;//fullName
            var userSex = data[j].userSex;//sexId
            if(userSex == "male"){
               var userSex = "01"; 
            }else if(userSex == "female"){
                var userSex = "02";
            }
            var mobileNo = data[j].mobileNo;//mobileNo手机号
            var email = data[j].email;//email邮箱
            var loginName = data[j].loginName;//loginName登陆姓名
            var officePhone = data[j].officePhone;//teleNo办公电话
            if(isSaas){
                var avatorLoc = data[j].avatorLoc
            }else{
                var avatorLoc0 = data[j].avatorLoc.split("/");//userIcon
                var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
            }
            var jobId = data[j].jobId;//roleId
            var jobName = data[j].jobName;//roleName
            var jobName1 = "";
            if(jobName){
                var jobArr = jobName.split(",");
                jobName1 = jobArr[0];
            }
            var topOrgIds = data[j].topOrgIds;//brcId
            var orgIds = data[j].orgIds;//dptId
            var higherLevelUniqueField = data[j].higherLevelUniqueField;//ldrUserId
            var higherLevelName = data[j].higherLevelName;//ldrFullName
            var leadname="";
            if(higherLevelName){
               leadname = higherLevelName.split(",")[0];
            }
            var positionTypeId = data[j].positionTypeId;//positionTypeId
            var positionTypeName = data[j].positionTypeName;
            var dptPerObj = {
                userId : uniqueField,
                fullName : name,
                sexId : userSex,
                mobileNo : mobileNo,
                email : email,
                loginName : loginName,
                mobileNo : mobileNo,
                teleNo : officePhone,
                userIcon : avatorLoc,
                roleId : jobId,
                roleName : jobName1,
                brcId : topOrgIds,
                dptId : orgIds,
                brcName : brcName,
                dptName : dptName,
                ldrUserId : higherLevelUniqueField,
                ldrFullName : leadname,
                positionTypeId : positionTypeId,
                positionTypeName : positionTypeName
            }
        }
        msgObj.msg.item.userId = uniqueField;
        msgObj.msg.item.entity= dptPerObj;
        callback(null,msgObj);
    },
    error : function(data) {
        callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
    }
    });
}
function perAllBydpt(dptId,callback){
    var msgObj = {
        msg:[],
        status:"000"
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    appcan.request.ajax({
        url : contactUrl+'getPersonnelByOrgId?accessToken='+accessToken+'&orgId='+dptId+'&domainName='+encodeURIComponent(domainName),
        type : 'GET',
        headers : getHeaders(),
        offline : true,
        offlineDataPath : 'box://icache/',
        contentType : 'application/x-www-form-urlencoded',
        timeout : "30000",
        data : {},
        success : function(data, status, xhr) {
             var data = JSON.parse(data);
            var dptPerArr = []; 
            for(var j = 0;j<data.length;j++){
                var orgName = data[j].orgName;//brcName/dptName
                var dptName = "";
                if(orgName){
                   var orgNames = orgName.split(",");
                   var orgNameArr = orgNames[0].split("/");
                   var brcName = orgNameArr[0];//机构名称
                   dptName = orgNameArr[orgNameArr.length - 1]; //部门名称
                }
                var personnelId = data[j].personnelId;//id
                var uniqueField = data[j].uniqueField;//userId
                var name = data[j].name;//fullName
                var userSex = data[j].userSex;//sexId
                if(userSex == "male"){
                   var userSex = "01"; 
                }else if(userSex == "female"){
                    var userSex = "02";
                }
                var mobileNo = data[j].mobileNo;//mobileNo手机号
                var email = data[j].email;//email邮箱
                var loginName = data[j].loginName;//loginName登陆姓名
                var officePhone = data[j].officePhone;//teleNo办公电话
                if(isSaas){
                    var avatorLoc = data[j].avatorLoc
                }else{
                    var avatorLoc0 = data[j].avatorLoc.split("/");//userIcon
                    var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
                }
                var jobId = data[j].jobId;//roleId
                var jobName = data[j].jobName;//roleName
                var jobName1 = "";
                if(jobName){
                    var jobArr = jobName.split(",");
                    jobName1 = jobArr[0];
                }
                var topOrgIds = data[j].topOrgIds;//brcId
                var orgIds = data[j].orgIds;//dptId
                var higherLevelUniqueField = data[j].higherLevelUniqueField;//ldrUserId
                var higherLevelName = data[j].higherLevelName;//ldrFullName
                var leadname="";
                if(higherLevelName){
                   leadname = higherLevelName.split(",")[0];
                }
                var positionTypeId = data[j].positionTypeId;//positionTypeId
                var positionTypeName = data[j].positionTypeName;
                var dptPerObj = {
                    userId : uniqueField,
                    fullName : name,
                    sexId : userSex,
                    mobileNo : mobileNo,
                    email : email,
                    loginName : loginName,
                    mobileNo : mobileNo,
                    teleNo : officePhone,
                    userIcon : avatorLoc,
                    roleId : jobId,
                    roleName : jobName1,
                    brcId : topOrgIds,
                    dptId : orgIds,
                    brcName : brcName,
                    dptName : dptName,
                    ldrUserId : higherLevelUniqueField,
                    ldrFullName : leadname,
                    positionTypeId : positionTypeId,
                    positionTypeName : positionTypeName
                }
                dptPerArr.push(dptPerObj);
            }
            msgObj.msg = dptPerArr;
            callback(null,msgObj);
        },
        error : function(data) {
            callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        }
    });
}
function selAllPerByEmm(uname,callback){
    var msgObj = {
        msg:[],
        status:"000"
    }
    var emmToken = JSON.parse(appcan.getLocVal("emmToken"));
    var accessToken = emmToken.info.accessToken;
    var indexInfo = JSON.parse(appcan.getLocVal("EMM_USER_INFO"));
    var brcId = indexInfo.loginUser.entity.brcId;
    appcan.request.ajax({
        url : contactUrl+'getPersonnelByName?accessToken='+accessToken+'&userName='+encodeURIComponent(uname)+'&domainName='+encodeURIComponent(domainName)+"&orgId="+brcId,
        type : 'get',
        headers : getHeaders(),
        contentType : 'application/x-www-form-urlencoded',
        timeout : "30000",
        data : {},
        success : function(data, status, xhr) {
             var data = JSON.parse(data);
            var dptPerArr = []; 
            for(var j = 0;j<data.length;j++){
                var orgName = data[j].orgName;//brcName/dptName
                var dptName = "";
                if(orgName){
                   var orgNames = orgName.split(",");
                   var orgNameArr = orgNames[0].split("/");
                   var brcName = orgNameArr[0];//机构名称
                   dptName = orgNameArr[orgNameArr.length - 1]; //部门名称
                }
                var personnelId = data[j].personnelId;//id
                var uniqueField = data[j].uniqueField;//userId
                var name = data[j].name;//fullName
                var userSex = data[j].userSex;//sexId
                if(userSex == "male"){
                   var userSex = "01"; 
                }else if(userSex == "female"){
                    var userSex = "02";
                }
                var mobileNo = data[j].mobileNo?data[j].mobileNo:"";//mobileNo手机号
                var email = data[j].email?data[j].email:"";//email邮箱
                var loginName = data[j].loginName;//loginName登陆姓名
                var officePhone = data[j].officePhone;//teleNo办公电话
                if(isSaas){
                    var avatorLoc = data[j].avatorLoc
                }else{
                    var avatorLoc0 = data[j].avatorLoc.split("/");//userIcon
                    var avatorLoc = avatorLoc0[(avatorLoc0.length-1)];
                }
                var jobId = data[j].jobId;//roleId
                var jobName = data[j].jobName;//roleName
                var jobName1="";
                if(jobName){
                    var jobArr = jobName.split(",");
                    jobName1 = jobArr[0];
                }
                var topOrgIds = data[j].topOrgIds;//brcId
                var orgIds = data[j].orgIds;//dptId
                var higherLevelUniqueField = data[j].higherLevelUniqueField;//ldrUserId
                var higherLevelName = data[j].higherLevelName;//ldrFullName
                var leadname="";
                if(higherLevelName){
                    leadname = higherLevelName.split(",")[0];
                }
                var positionTypeId = data[j].positionTypeId;//positionTypeId
                var positionTypeName = data[j].positionTypeName;
                var dptPerObj = {
                    userId : uniqueField,
                    fullName : name,
                    sexId : userSex,
                    mobileNo : mobileNo,
                    email : email,
                    loginName : loginName,
                    mobileNo : mobileNo,
                    teleNo : officePhone,
                    userIcon : avatorLoc,
                    roleId : jobId,
                    roleName : jobName1,
                    brcId : topOrgIds,
                    dptId : orgIds,
                    brcName : brcName,
                    dptName : dptName,
                    ldrUserId : higherLevelUniqueField,
                    ldrFullName : leadname,
                    positionTypeId : positionTypeId,
                    positionTypeName : positionTypeName
                }
                dptPerArr.push(dptPerObj);
            }
            msgObj.msg = dptPerArr;
            callback(null,msgObj);
        },
        error : function(data) {
            callback(-1000,{status:-30001,msg:{message:"网络请求异常，请检查网络是否正常。"}});
        }
    });
}
