var userInfoModel = Backbone.Model.extend({
    idAttribute:"userId",
    initialize: function(model,option) {
        if(option){
            var userInfo = appcan.getLocVal("CACHE_USERINFO_"+option.userId.toUpperCase()) || '{}';
            this.set(JSON.parse(userInfo));
            
            this.on("change",function(){
                appcan.setLocVal("CACHE_USERINFO_"+option.userId.toUpperCase(),JSON.stringify(this.toJSON()))
            })
            
        }
        
    },
    parse : function(resp) {
        try{
        if(resp.msg){
            return resp.msg.item.entity;
        }else{
            return resp;
        }
        }catch(e){
            ALERT_ERROR("userInfoModel","parse",e.message+'--'+e.stack)
        }
    },
    validate : function(attrs, options) {
        try{
        if (attrs.mobileNo && !tools.TEL_REG.test(attrs.mobileNo)) {
            return "请输入正确的座机号";
        }
        if (attrs.teleNo && !tools.PHONE_REG.test(attrs.teleNo)) {
            return "请输入正确的座机号";
        }
        if (attrs.email && !tools.EMAIL_REG.test(attrs.email)) {
            return "请输入正确的邮箱";
        }
        }catch(e){
            ALERT_ERROR("userInfoModel","validate",e.message+'--'+e.stack)
        }
    },
    sync : function(method, model, options) {
        try{
        switch(method) {
        case "create":
        case "update":
        case "patch":
        
            userInfoService.requestSubmit(this.toJSON(), options);
           
            break;
        case "read":
            userInfoService.request({}, options);
            break;
        case "delete":
            break;
        default:
            break;
        }
        }catch(e){
            ALERT_ERROR("userInfoModel","sync",e.message+'--'+e.stack)
        }
    }
})
