var chatGroupMemberTemplate = loadTemplate("assets/templates/chatGroupMember.tpl");
var applistData = [];
var chatGroupMemberView = Backbone.View.extend({
    initialize : function(){
        this.model.view = this;
        this.render();
        var userId = this.model.get("userId");
        if(userId){
            this.model.on("change",function(){
                appcan.setLocVal("CACHE_USERINFO_"+userId.toUpperCase(),JSON.stringify(this.toJSON()))
            })
            appcan.setLocVal("CACHE_USERINFO_"+userId.toUpperCase(),JSON.stringify(this.model.toJSON()))
        }
    },
    template : chatGroupMemberTemplate,
    dealIcon : function(icon){
        if (icon)
            return 'lazy" data-original="' + constant.IMG_URL + icon;
        return "";
    },
    render : function(){
        var self = this;
        //alert(this.model.attributes.msg.JSON.stringify());
        if(this.template){
            this.$el = $(this.template({
                    data:this.model.attributes,
                    dealIcon : self.dealIcon
                }));
            appcan.button(this.$el,"btn-act",function(){
                var chatId = self.model.get("userId");
                var userIcon = self.model.get("userIcon");
                var fullName = self.model.get("fullName");
                appcan.setLocVal(storeKey.CONTACT_ICON, userIcon);
                appcan.setLocVal(storeKey.PERSON_NAME, fullName);
                appcan.setLocVal(storeKey.CONTACT_NAME, fullName);
                appcan.setLocVal(storeKey.PERSON_ID, chatId);
                if(isAndroid){
                    appcan.window.open("contactsMain", "contactsMain.html", 10,64);
                }else{
                    appcan.window.open("contactsMain", "contactsMain.html", 10);
                }
            });
            $(".deleteOption",this.$el).off('longTap').on('longTap', function() {
                uexWindow.cbActionSheet = function(a, b, data) {
                    switch(parseInt(data)) {
                        case 0:{
                            var userId = self.model.get("userId");
                            var loginId = (appcan.getLocVal("userIdIm")).toLowerCase();
                            appcan.setLocVal("delUserid",userId);
                            if(userId == loginId){
                               appcan.window.openToast("不能将自己剔除",2000,5);
                            }else{
                                //将某人剔除群
                                var groupName = appcan.getLocVal("qunId");
                                var param = {
                                    groupName:groupName,
                                    imId:userId,
                                    reason:""
                                };
                                var params = JSON.stringify(param);
                                uexIM.kickFromChatGroup(params);
                            }
                        }
                        break;

                    }
                }
                var str = ["删除"];
                uexWindow.actionSheet("菜单", "取消", str);
            });
        };

        return this;
    }
})

var memberListView = Backbone.View.extend({
    initialize : function(){
        this.listenTo(this.collection,"add",this.addView);
        this.listenTo(this.collection,"remove",this.removeView);
    },
    collection : new memberListCollection(),
    el:"#members > div",
    load : function(){
        var self = this;
        self.groupObjIds = appcan.getLocVal("groupObjIds");
        var perArr = JSON.parse(appcan.getLocVal("personId"));
        var relation = [];
        var num = Math.min(perArr.length,20);
        for(var j=0;j<num;j++){
            var userid = perArr[j];
            var obj = {
                userId :userid
            }
            relation.push(obj);
        };
        this.collection.fetch({
            success : function(data,resp,option){
                $("div.lazy").lazyload({
                    cache:true
                });
            },
            error : function(err,resp,option){
                switch(error.status) {
                default:
                    global_error(error);
                    break;
                }
            },
            idArr : relation
        })
    },
    addView : function(model){
        var view = new chatGroupMemberView({
            model : model
        });
        this.$el.append(view.$el)
    },
    removeView : function(model){
        var view = model.view;
        if(view) view.remove();
    }
})

var memberListViewInstance = new memberListView();
appcan.ready(function(){
    appcan.window.subscribe("cb_KickFromChatGroup", function(result) {
       var data = JSON.parse(result);
       var dataVal = Number(data.result);
       if(dataVal==1){
           //先把当前删除的人,从条件中排除再去请求接口
           var arrPer = JSON.parse(appcan.getLocVal("personId"));
           var delPer = appcan.getLocVal("delUserid");
           var relationArr = [];
            for(var n=0;n<arrPer.length;n++){
                var userid = arrPer[n];
                if(delPer.toLowerCase()==userid.toLowerCase()){
                }else{
                  relationArr.push(userid);
                }
            }
           appcan.setLocVal("personId",relationArr);
           var delId = delPer;
           memberListViewInstance.collection.remove(memberListViewInstance.collection.get(delId));
           $("#perCount").html(relationArr.length);
       }else{
           appcan.window.openToast("网络错误",1500,5);
       }
   })
})
