var chatGroupMemberListTemplate = loadTemplate("assets/templates/chatGroupMemberList.tpl");
var curChatTarget = null;
var chatGroupMemberItemView = Backbone.View.extend({
    initialize : function(){
        this.model.view = this;
        this.render();
        var userId = this.model.get("userId");
        if(userId){
            this.model.on("change",function(){
                appcan.setLocVal("CACHE_USERINFO_"+userId.toUpperCase(),JSON.stringify(this.toJSON()))
            })
            appcan.setLocVal("CACHE_USERINFO_"+userId.toUpperCase(),JSON.stringify(this.model.toJSON()))
        }
    },
    template : chatGroupMemberListTemplate,
    dealIcon : function(icon){
        if (icon)
            return 'lazy" data-original="' + constant.IMG_URL + icon;
        return "";
    },
    render : function(){
        var self = this;
        //alert(this.model.attributes.msg.JSON.stringify());
        if(this.template){
            this.$el = $(this.template({
                    data:this.model.attributes,
                    dealIcon : self.dealIcon
                }));
            this.bindingEvents();
        };

        return this;
    },
    bindingEvents : function() {
        var self = this;
        appcan.button($(".scroll-bar",this.$el),"",function(){
            var chatId = self.model.get("userId");
            var userIcon = self.model.get("userIcon");
            var fullName = self.model.get("fullName");
            appcan.setLocVal(storeKey.CONTACT_ICON, userIcon);
            appcan.setLocVal(storeKey.PERSON_NAME, fullName);
            appcan.setLocVal(storeKey.CONTACT_NAME, fullName);
            appcan.setLocVal(storeKey.PERSON_ID, chatId);
            if(isAndroid){
                appcan.window.open("contactsMain", "contactsMain.html", 10,64);
            }else{
                appcan.window.open("contactsMain", "contactsMain.html", 10);
            }
        });
        appcan.button($(".scroll-right", this.$el), "", function() {
            var userId = self.model.get("userId");
            var loginId = (appcan.getLocVal("userIdIm")).toLowerCase();
            appcan.setLocVal("delUserid",userId);
            if(userId == loginId){
               appcan.window.openToast("不能将自己剔除",2000,5);
            }else{
                //将某人剔除群
                var groupName = appcan.getLocVal("qunId");
                var param = {
                    groupName:groupName,
                    imId:userId.toLowerCase(),
                    reason:""
                };
                var params = JSON.stringify(param);
                uexIM.kickFromChatGroup(params);
            }
        })
        $(this.$el).on("touchstart", function() {
            curChatTarget = self;
        })
    },
    swipeLeft : function() {
        var width = $(".scroll-right", this.$el).width();
        $(".scroll-bar", this.$el).css("-webkit-transform", "translateX(-" + width + "px)");
    },
    swipeRight : function() {
        var width = $(".scroll-right", this.$el).width();
        $(".scroll-bar", this.$el).css("-webkit-transform", "translateX(" + 0 + "px)");
    }
})

var memberListView = Backbone.View.extend({
    initialize : function(){
        this.listenTo(this.collection,"add",this.addView);
        this.listenTo(this.collection,"remove",this.removeView);
    },
    collection : new memberListCollection(),
    el:"#list",
    load : function(){
        appcan.window.openToast("加载中");
        var self = this;
        self.groupObjIds = appcan.getLocVal("groupObjIds");
        var perArr = JSON.parse(appcan.getLocVal("personId"));
        var relation = [];
        var num = perArr.length;
        for(var j=0;j<num;j++){
            var userid = perArr[j];
            var obj = {
                userId :userid
            }
            relation.push(obj);
        };
        this.collection.fetch({
            success : function(data,resp,option){
                appcan.window.closeToast()
                $("div.lazy").lazyload({
                    cache:true
                });
            },
            error : function(err,resp,option){
                appcan.window.closeToast()
                switch(error.status) {
                default:
                    global_error(error);
                    break;
                }
            },
            idArr : relation
        })
    },
    addView : function(model){
        var view = new chatGroupMemberItemView({
            model : model
        });
        this.$el.append(view.$el)
    },
    removeView : function(model){
        var view = model.view;
        if(view) view.remove();
    }
})

var groupMemberListViewInstance = new memberListView();
appcan.ready(function(){
    try{
        var param = {
            isSupport:true
        };
        uexWindow.setIsSupportSwipeCallback(JSON.stringify(param));
    }catch(e){}
    appcan.initBounce();
    groupMemberListViewInstance.load();
    appcan.window.swipeLeft(function(){
        curChatTarget && curChatTarget.swipeLeft();
        curChatTarget = null;
    })
    appcan.window.swipeRight(function(){
        curChatTarget && curChatTarget.swipeRight();
        curChatTarget = null;
    })
    appcan.window.subscribe("cb_KickFromChatGroup", function(result) {
       var data = JSON.parse(result);
       var dataVal = Number(data.result);
       if(dataVal==1){
           //先把当前删除的人,从条件中排除再去请求接口
           var arrPer = JSON.parse(appcan.getLocVal("personId"));
           var delPer = appcan.getLocVal("delUserid");
           var relationArr = [];
            for(var n=0;n<arrPer.length;n++){
                var userid = arrPer[n];
                if(delPer.toLowerCase()==userid.toLowerCase()){
                }else{
                  relationArr.push(userid);
                }
            }
           appcan.setLocVal("personId",relationArr);
           var delId = delPer;
           groupMemberListViewInstance.collection.remove(groupMemberListViewInstance.collection.get(delId));
           appcan.window.publishForJson("PERSON_LENGTH",{num:relationArr.length,userId:delId})
           //selPerson(0);
       }else{
           appcan.window.openToast("网络错误",1500,5);
       }
   })
})
