//加载并初始化模板对象
var chatTextLeftTemplate = loadTemplate("assets/templates/chatTextLeft.tpl");
var chatTextRightTemplate = loadTemplate("assets/templates/chatTextRight.tpl");
var chatPicRightTemplate = loadTemplate("assets/templates/chatPicRight.tpl");
var chatPicLeftTemplate = loadTemplate("assets/templates/chatPicLeft.tpl");
var chatVoiceRightTemplate = loadTemplate("assets/templates/chatVoiceRight.tpl");
var chatVoiceLeftTemplate = loadTemplate("assets/templates/chatVoiceLeft.tpl");
var chatFileRightTemplate = loadTemplate("assets/templates/chatFileRight.tpl");
var chatFileLeftTemplate = loadTemplate("assets/templates/chatFileLeft.tpl");

var chatView = Backbone.View.extend({ //options...
    initialize: function(option) {
        try {
            if (option.userId) {
                this.userModel = new userInfoModel({}, {
                    userId: option.userId
                });
            }
            this.model.view = this;
            this.render();
            if (option.userId) {
                this.listenTo(this.userModel, "change", this.updateUserInfo);
                this.updateUserInfo()
            }

        } catch (e) {
            alert(e.message)
        }
    },
    render: function() {
        try {
            var self = this;
            //获取是发送者还是接受者;0是接受者 1是发送者
            var isSend = self.model.get("isSend");
            //1-发送中，2-发送成功，3-发送失败。
            var sendStatus = self.model.get("sendStatus");
            //消息类型，1-文本；2-图片；3-语音；
            var msgType = self.model.get("msgType");
            var msgSender = self.model.get("msgSender");
            var msgId = self.model.get("msgId");
            var groupName = self.model.get("groupID");
            var dparam = {
                groupName: groupName,
                msgId: msgId
            }
            var dparams = JSON.stringify(dparam);
            appcan.logs("--groupchat-----" + JSON.stringify(self.model.toJSON()))
            var obj = {
                data: self.model.attributes,
                formatContent: function(d) {
                    if(d=='' || d==null || !isDefine(d)){
                    return ''
                }
                    if(d.indexOf("长按消息加入:") > -1){
                 d = d.split(':')[0];
              }
                    d = replaceURLToLink(d);
                    d = replacePhoneToCall(d);
                    d  =  d.replace(tools.IM_EXPRESSION, self.change);
                    d = d.replace(/wgtRes/g, chatListViewInstance.path);
                    if (msgType == 10) { //图文混排
                  var start = '<img style="min-width:1px;min-height:1px;max-width:7.5em;max-height: 7.5em;border-radius: .2em;background-color:white" class="pic lazy piclist" ';
                        d  =  d.replace(/&lt;img(.*)src=(.*)\/&gt;/ig, function(a) {
                            a = a.replace(/&quot;/g, "'").replace(/src=[\'\"]?([^\'\"]*)[\'\"]?/i, function(b) {
                                c = b.substring(b.indexOf("=") + 1);
                                return " data-original=" + c + " ";
                            }).replace("&lt;img", start)
                            return a;
                        }).replace(/&gt;/g, ">").replace(/&lt;/g, "<").replace(/&nbsp;/g, " ").replace(/&quot;/g, "'");
                    }
                    d = d.replace(/\n/g, "<br>")
                    return d;
                },
                setName: function(userId) {
                return "　";
            },
            dealIconName:function(){
                var name = chatListViewInstance.selfName;
                var lastNameStr = '';
                if(name){
                    var lastName = name.substr((name.length)-1,1);
                    lastNameStr = '<div style="line-height:2.5em; text-align:center;color:#ffffff;">'+lastName+'</div>';
                    if (chatListViewInstance.selfIcon){
                        if(chatListViewInstance.selfIcon.indexOf("icache")>0 && chatListViewInstance.selfIcon.indexOf("http")!=0){//已下载
                            return "";
                        }
                    }
                }
                return lastNameStr;
                },
            dealIconChatName:function(userId){
                var userId = $.trim(userId).toLowerCase();
                var name = chatListViewInstance['chatN'+userId];
                var lastNameStr = '';
                if(name){
                    var lastName = name.substr((name.length)-1,1);
                    var lastNameStr = '<div style="line-height:2.5em; text-align:center;color:#ffffff;">'+lastName+'</div>';
                }
                if (chatListViewInstance['chat'+userId]){
                    if(chatListViewInstance['chat'+userId].indexOf("icache")>0 && chatListViewInstance['chat'+userId].indexOf("http")!=0){//已下载
                        return '';
                    }
                }
                return lastNameStr;
            },
                dealIcon: function() {
                var name = chatListViewInstance.selfName;
                var lastName = name.substr((name.length)-1,1);
                var lastNameSP = shouPin.getCamelChars(lastName);
                    if (chatListViewInstance.selfIcon) {
                    if(chatListViewInstance.selfIcon.indexOf("icache")>0 && chatListViewInstance.selfIcon.indexOf("http")!=0){//已下载
                        var str = ' "style="background-image:url('+chatListViewInstance.selfIcon+')!important;background-color:'+generateColor(lastNameSP);
                        return str;
                        }
                    return 'lazy selfIcon" style="background-color:'+generateColor(lastNameSP)+'" data-original="' + constant.IMG_URL + chatListViewInstance.selfIcon;
                    }

                return 'lazy selfIcon"style="background-color:'+generateColor(lastNameSP);
                },
                dealIconChat: function(userId) {
                    var userId = $.trim(userId).toLowerCase();
                var name = chatListViewInstance['chatN'+userId];
                var lastNameSP = '';
                if(name){
                    var lastName = name.substr((name.length)-1,1);
                    var lastNameSP = shouPin.getCamelChars(lastName);
                }
                    if (chatListViewInstance['chat' + userId]) {
                    if(chatListViewInstance['chat'+userId].indexOf("icache")>0 && chatListViewInstance['chat'+userId].indexOf("http")!=0){//已下载
                        var str = ' "style="background-image:url('+chatListViewInstance['chat'+userId]+')!important;background-color:'+generateColor(lastNameSP);
                        return str;
                    }
                    return ' chat'+userId+'" style="background-color:'+generateColor(lastNameSP)+'" data-original="'  + chatListViewInstance['chat'+userId];
                    }

                return ' chat'+userId+'" style="background-color:'+generateColor(lastNameSP);
                },
                resPath: function(path) {
                    var lujing = path.substring((path.lastIndexOf("/")) + 1, path.length);
                    if (lujing.length > 12) {
                        var lujing1 = lujing.substring((lujing.lastIndexOf(".")), lujing.length);
                        lujing = lujing.substring(0, 8) + "..." + lujing.substring(lujing.lastIndexOf(".") - 4, lujing.lastIndexOf(".")) + lujing1;
                    }
                    return lujing;
                },
                fileName: function(file) {
                    var lujing = file;
                    if (lujing.length > 12) {
                        var lujing1 = lujing.substring((lujing.lastIndexOf(".")), lujing.length);
                        lujing = lujing.substring(0, 8) + "..." + lujing.substring(lujing.lastIndexOf(".") - 4, lujing.lastIndexOf(".")) + lujing1;
                    }
                    return lujing;
                },
                loadStatu: function(dlstatus) {
                    //alert(dlstatus);
                    var dlStatus;
                    if (dlstatus == 0) {
                        dlStatus = "未下载";
                    } else if (dlstatus == 1) {
                        dlStatus = "下载中";
                    } else if (dlstatus == 2) {
                        dlStatus = "下载完成";
                    } else if (dlstatus == 3) {
                        dlStatus = "下载失败";
                    };
                    return dlStatus;
                }
            }
            if (isSend) {
                switch (msgType) {
                case 10://图文混排
                    case 1: //文本
                        self.$el = $(chatTextRightTemplate(obj));
                        break;
                    case 2: //图片
                        self.$el = $(chatPicRightTemplate(obj));
                        break;
                    case 3: //语音
                        {
                            self.$el = $(chatVoiceRightTemplate(obj));
                            var dura = self.model.get("voiceTime");
                            var dura = Number(dura);
                            if (dura <= 3) {
                                $(".voice", self.$el).css('width', '3.5em');
                            } else if (3 < dura <= 60) {
                                var dur = 3.5 + (dura - 3) * 0.1;
                                $(".voice", self.$el).css('width', dur + 'em');
                            }
                            appcan.button($(".audioPlay", self.$el), "ani-act", function() {
                                var path = $(this).find("div.uhide").html();
                                uexAudio.stop();
                                var $currPlayBtn = $(this).find("div.yuyinImg");
                                $currPlayBtn.removeClass('yuyin2').addClass('yuyin2Gif');
                                self.baseView.$currPlayBtns.push($currPlayBtn);
                                self.playBgRecord(path);
                            });
                        }
                        break;
                    case 7: //文件
                        {
                            self.$el = $(chatFileRightTemplate(obj));
                            appcan.button($(".fileMgr", self.$el), "", function(a) {
                                var path = this.id;
                                if (path == undefined) {} else {
                                    uexDocumentReader.openDocumentReader(path);
                                }
                            });
                        }
                        break;
                    default:
                        break;
                }
            } else {
                switch (msgType) {

                    case 1: //文本
                        self.$el = $(chatTextLeftTemplate(obj));
                        break;
                    case 2: //图片
                        self.$el = $(chatPicLeftTemplate(obj));
                        if ((self.model.get("dlstatus")) == 0) {
                            uexIM.downloaderGroupMgr(dparams);
                        }
                        break;
                    case 3: //语音

                        {
                            self.$el = $(chatVoiceLeftTemplate(obj));
                            var dura = self.model.get("voiceTime");
                            var dura = Number(dura);
                            if (dura <= 3) {
                                $(".voice", self.$el).css('width', '3.5em');
                            } else if (3 < dura <= 60) {
                                var dur = 3.5 + (dura - 3) * 0.1;
                                $(".voice", self.$el).css('width', dur + 'em');
                            }
                            if ((self.model.get("dlstatus")) == 0) {
                                uexIM.downloaderGroupMgr(dparams);
                            }
                            appcan.button($(".audioPlay", self.$el), "ani-act", function() {
                                var opacity = $(this).css("opacity");
                                if (opacity == "0.4") {
                                    return;
                                } else {
                                    var path = $(this).find("div.uhide").html();
                                    $(this).siblings("div.yuand").removeClass("yuand");
                                    var groupName = self.model.get("groupID");
                                    var msgId = self.model.get("msgId");
                                    var params = {
                                        groupName: groupName,
                                        msgId: msgId
                                    }
                                    var params1 = JSON.stringify(params)
                                    uexIM.setVoiceGroupMsgRead(params1);
                                    uexAudio.stop();
                                    var $currPlayBtn = $(this).find("div.yuyinImg");
                                    $currPlayBtn.removeClass('yuyin').addClass('yuyinGif');
                                    self.baseView.$currPlayBtns.push($currPlayBtn);
                                    self.playBgRecord(path);
                                }
                            });
                        }

                        break;
                    case 7: //文件
                        {
                            self.$el = $(chatFileLeftTemplate(obj));
                            if ((self.model.get("dlstatus")) == 0) {
                                appcan.button($(".xiazai", self.$el), "", function() {
                                    uexIM.downloaderGroupMgr(dparams);
                                    event.stopPropagation();
                                });
                            }
                            appcan.button($(".fileMgr", self.$el), "", function(a) {
                                var path = this.id;
                                if (path == undefined) {} else {
                                    var cur = $(".xiazai", $(this));
                                    if (cur[0] && cur.html().indexOf("下载完成") < 0) {
                                        uexIM.downloaderChatMgr(dparams);
                                        event.stopPropagation();
                                        return;
                                    }
                                    uexDocumentReader.openDocumentReader(path);
                                }
                            });
                        }
                        break;
                    default:
                        break;
                }
            }
        } catch (e) {
            //alert(e.message+'---'+e.stack)
            appcan.logs("e.message+-"+e.message+"--"+e.stack);
        }
        this.bindingEvents();
        return this;
    },
    change: function(s) { //IM表情替换图片
        return '<img style="width:1.5em;height:1.5em;"  src="wgtResemojicons/' + biaoqing[s] + '" border="0" align="center">';
    },
    bindingEvents: function() {
        var self = this;
        $(".textType", self.$el).off('longTap').on('longTap', function() {
            var _this = this;
            var content = $(this).children().children().data("data");
            uexWindow.cbActionSheet = function(a, b, data) {
                switch (parseInt(data)) {
                    case 0:
                        if (decodeURIComponent(content).indexOf("长按消息加入:") > -1) {
                            confirm2(function(i) {
                                if (i == 1) {

                                    var videoID = decodeURIComponent(content).split(':')[1];
                                    appcan.setLocVal("iscreater", videoID);
                                    appcan.window.openToast('加入视频会议中');
                                    appcan.setLocVal("loginingVidio", 1);
                                    appcan.window.publish('E_SFSP_INITLOGIN');
                                    appcan.locStorage.setVal("isGroupVidio",1);
                                }
                            }, '是否加入视频会议?')

                        } else {
                            uexClipboard.copy(decodeURIComponent(content));

                        }
                        break;
                }
            }
            if(decodeURIComponent(content).indexOf("长按消息加入:") > -1){
             var str = ["加入"];
             uexWindow.actionSheet("菜单", "取消", str);
            }else{
             var str = ["复制"];
             uexWindow.actionSheet("菜单", "取消", str);
            }
        });
        appcan.button($(".urlGO", self.$el), "", function(a) {
            var json = {name:$(this).text(),url:decodeURIComponent($(this).data("data")),"extraInfo":{"opaque":"true","bgColor":"#ecf3f7","delayTime":"250"}}
            appcan.setLocVal("CARD_PARAM", json);
            appcan.window.open("webWind", "webWind.html", 10)
        });
        appcan.button($(".pic",self.$el), "", function(a) {
            var array = [];
            var cure = $(".piclist",self.$el)[0];
            var url = cure.id || cure.src;
            var itemId = self.model.get("msgId") + "abc";
            if($(".percent",$(cure))[0] || ($(".huihuaunloadfail",$("#"+itemId))[0]&&!$(".huihuaunloadfail",$("#"+itemId)).hasClass("uhide"))){
                return;
            }
            //array[0] = url;
            var n = 0;
            var startIndex = 0;
            $('.piclist').each(function(index) {
                var url1 = this.id || this.src;
                var msgid = $(this).data("msgid")
                if(!$(".huihuaunloadfail",$("#"+msgid))[0] || (!$(".percent",$(this))[0] && $(".huihuaunloadfail",$("#"+msgid)).hasClass("uhide"))){
                if (url == url1) {
                    startIndex = n;
                }
                n++;
                array.push(url1);
                }
            })
            var param = {
                startIndex: startIndex,
                data: array
            }
            param = JSON.stringify(param);
            if (url == undefined) {
            } else {
                uexImage.openBrowser(param);
            }
        });
        appcan.button($(".huihuaunload", self.$el), "", function() {
            var msgId = self.model.get("msgId");
            var msgtype = self.model.get("msgType");
            appcan.setLocVal("failedId1", msgId);
            appcan.setLocVal("failedType1", msgtype);
            cbActionSheetRe();
            var str = ["重新发送"];
            uexWindow.actionSheet("菜单", "取消", str);
        });
        appcan.button($(".huihuaunloadfail", self.$el), "", function() {
            var groupName = self.model.get("groupID");
            var msgId = self.model.get("msgId");
            var dparam = {
                groupName: groupName,
                msgId: msgId
            }
            var dparams = JSON.stringify(dparam);
            uexWindow.cbActionSheet = function(a, b, data) {
                switch (parseInt(data)) {
                    case 0:

                        uexIM.downloaderGroupMgr(dparams);
                        break;
                }
            }
            var str = ["重新加载"];
            uexWindow.actionSheet("菜单", "取消", str);
        });
        appcan.button($(".yuyinfail", self.$el), "", function() {
            var groupName = self.model.get("groupID");
            var msgId = self.model.get("msgId");
            var dparam = {
                groupName: groupName,
                msgId: msgId
            }
            var dparams = JSON.stringify(dparam);
            uexWindow.cbActionSheet = function(a, b, data) {
                switch (parseInt(data)) {
                    case 0:
                        uexIM.downloaderGroupMgr(dparams);
                        break;
                }
            }
            var str = ["重新加载"];
            uexWindow.actionSheet("菜单", "取消", str);
        });
        appcan.button($(".leftPerson",self.$el),"",function(){
            var chatId = self.model.get("msgSender");
            var userIcon = self.userModel.get("userIcon");
            var fullName = self.userModel.get("fullName");
            if(!fullName) return;
            appcan.setLocVal(storeKey.CONTACT_ICON, userIcon);
            appcan.setLocVal(storeKey.PERSON_NAME, fullName);
            appcan.setLocVal(storeKey.CONTACT_NAME, fullName);
            appcan.setLocVal(storeKey.PERSON_ID, chatId);
            if(isAndroid){
                appcan.window.open("contactsMain", "contactsMain.html", 10,64);
            }else{
                appcan.window.open("contactsMain", "contactsMain.html", 10);
            }
        });
    },
    updateView: function(model) {
        // appcan.logs("update--" + JSON.stringify(model.toJSON()))
        var self = this;
        var chatType = Number(model.get("chatType"));
        var sendStatus = Number(model.get("sendStatus"));
        var msgId = model.get("msgId");
        if (sendStatus == 1) { //发送中
        } else if (sendStatus == 2) { //发送成功
            $("#"+msgId+'_').css("opacity","1");
           if($(".iconwhh1",self.$el)[0]){$(".iconwhh1",self.$el).removeClass("huihuaunload1").removeClass("huihuaunload");}
            var con = model.get("content");
            if(isDefine(con) && con.indexOf("location")==0){
                 lazyLoadImage(con.substring(8),self.$el,function(path,s){
                    var dom  = $(".mapUrl",s.dom)
                    dom.css("background-image", "url(file://" + path + ") !important")
                    dom.empty();
                })
            }
        } else if (sendStatus == 3) { //发送失败
           $(".iconwhh1",self.$el).removeClass("huihuaunload1").addClass("huihuaunload");
        }
        appcan.button($(".huihuaunload", self.$el), "", function() {
            var msgId = self.model.get("msgId");
            var msgtype = self.model.get("msgType");
            appcan.setLocVal("failedId1", msgId);
            appcan.setLocVal("failedType1", msgtype);
            cbActionSheetRe();
            var str = ["重新发送"];
            uexWindow.actionSheet("菜单", "取消", str);
        });
    },
    conver: function() {

    },
    dateSet: function(d) {
        var time = NYR(d, 1);
        var nyr = NYR('', 1);
        if (time == nyr) {
            var cTime = HM(d);
        } else {
            var cTime = NYR(d, 0);
        }
        return cTime;
    },
    playBgRecord: function(recordPath) { //点击音频文件，播放录音
        var param = {
            playMode: 0
        };
        param = JSON.stringify(param);
        uexAudio.setPlayMode(param);
        uexAudio.open(recordPath);
        uexAudio.setProximityState('1');
        uexAudio.play('0');
    },
    loadUserInfo : function(model) {
        var self = this;
        self.userModel.fetch({
            success : function(cols, resp, options) {
                self.updateUserInfo();
            },
            error : function(cols, error, options) {
            },
            staffId: self.model.get("msgSender")
        });
    },
    updateUserInfo: function() {
        var self = this;
        try {
            self.setUserIcon();
            $(".fullName", self.$el).html(self.userModel.get("fullName"));
        } catch (e) {
           // alert(e.message);
        }
    },
    setUserIcon: function() {
        var self = this;
        var icon = self.userModel.get("userIcon");
        var userId = $.trim(self.userModel.get("userId")).toLowerCase();
        var name = self.userModel.get("fullName");
        var lastName = name.substr((name.length)-1,1);
        var lastNameSP = shouPin.getCamelChars(lastName);
        lastNameStr = '<div style="text-align:center;color:#ffffff;">'+lastName+'</div>';
        $('.chat'+userId,self.$el).css("background-color",generateColor(lastNameSP));
        //if(!chatListViewInstance['chatN'+userId])
        $('.chat'+userId,self.$el).html(lastNameStr);
        chatListViewInstance['chatN'+userId] = name;
         appcan.logs('setUserIcon-icon-----'+ icon)
        if (icon) {
            if (!chatListViewInstance['chat' + userId]) {
                setChatIcon(icon,chatListViewInstance,'chat'+userId);
            }else{
                $('.chat'+userId,self.$el).html("");
                $(('.chat'+userId),self.$el).css("background-image",'url('+chatListViewInstance['chat'+userId]+')!important;')
            }

        }

    }
});

//列表容器VIEW
var chatListView = Backbone.View.extend({ //options...

    initialize: function() {
        var self = this;
        self.collection = new chatGroupCollection(); //collection，用于存储和管理数据
        self.listenTo(self.collection, "add", self.add);
        self.listenTo(self.collection, 'sort', self.sort);
        self.listenTo(self.collection, "change", self.updateView);
        self.listenTo(self.collection, "remove", self.removeView);

    },
    //collection : new chatCollection(), //collection，用于存储和管理数据
    pageCount: 10,
    el: '#huihuainfolist', //VIEW 对应 HTML 元素CSS选择器
    $currPlayBtns: [],
    handlePlayEnd: function() {
        var _hanlder = function($currPlayBtn) {
            if ($currPlayBtn.hasClass('yuyin2Gif')) {
                $currPlayBtn.removeClass('yuyin2Gif').addClass('yuyin2');
            } else if ($currPlayBtn.hasClass('yuyinGif')) {
                $currPlayBtn.removeClass('yuyinGif').addClass('yuyin');
            }
        };
        var length = this.$currPlayBtns.length;
        if (length == 1) {
            _hanlder(this.$currPlayBtns[0]);
            this.$currPlayBtns = [];
        } else {
            this.$currPlayBtns.forEach(function($currPlayBtn, index) {
                if (index < length - 1) {
                    _hanlder($currPlayBtn);
                }
            });
            this.$currPlayBtns.splice(0, length - 1);
        }
    },
    getChatList: function(t) { //HTML页面调用的初始化接口，由于通讯有可能依赖APPCAN组件，因此封装此接口在appcan.ready中调用
        var self = this;
        var listObj = {
            groupName: self.groupName,
            msgCount: self.pageCount
        }
        if (t == 0) {
            listObj.startTime = self.chatTime;
        }
        this.collection.fetch({
            channel: "E_XMPP_GETGROUPCHATLIST",
            param: listObj,
            t: t,
            success: function(cols, resp, options) {
                // appcan.frame.resetBounce(t);
                if (t == 1) {
                    var data = resp[0];
                    self.chatTime = data.timestamp;
                    window.scrollTo(0, document.body.scrollHeight);
                } else {
                    var data = resp[resp.length - 1];
                    self.chatTime = data.timestamp;
                }
                setTimeout(function() {
                    $(".lazy").lazyload({
                        cache: true,
                        threshold: 200,
                        failure_limit: 15
                    });
                }, 500)

            },
            error: function(cols, error, options) {
                // appcan.frame.resetBounce(t);
            },
            add: true,
            remove: t ? true : false,
            merge: true,
            pre: t ? false : true,
            t: t
        });
    },
    sendMsg: function(msg, channel) {
        var self = this;
        if (channel == "E_XMPP_SENDMSGTEXTG") {
            appcan.window.publishForJson(channel, msg);
        } else {
            appcan.window.publish(channel, msg);
        }
    },
    newEl: $("<div></div>"),
    firstEl: $("<div></div>"),
    add: function(model, res, op) {
        try {
            console.log(1)
            var itemTime = model.get("timestamp") || Date.now();
            model.set("timestamp", itemTime)
            if (!op.pre) {
                this.setTimeShow(itemTime, this.firstEl);
            }
            if (model.get("msgSender") != this.selfUserId.toLowerCase()) {
                var view = new chatView({
                    model: model,
                    userId: model.get("msgSender")
                });
                view.baseView = this;
            } else {
                var view = new chatView({
                    model: model,
                });
                view.baseView = this;
            }
            console.log(2)
            var total = res.toJSON();
            if (!op.pre) {
                this.firstEl.append(view.$el);
                if (total[total.length - 1].msgId == model.get("msgId")) {
                    this.$el.append(this.firstEl);
                    if (op.t && op.t == 1) {
                        window.scrollTo(0, document.body.scrollHeight);
                    } else {
                        this.toDown();
                    }

                }

            } else {
                this.newEl.prepend(view.$el);

                if (total[total.length - 1].msgId == model.get("msgId")) {
                    this.$el.prepend(this.setFormTime(model.get("timestamp")));
                    var tempEl = $("<div></div>");
                    tempEl.insertAfter(this.$el.children().first());
                    tempEl.html(this.newEl);
                    $("<div id='__" + model.get("msgId") + "'></div>").insertAfter(tempEl);
                    location.href = "#__" + model.get("msgId");
                    this.newEl = $("<div></div>");
                }
            }
            if (model.get("msgSender") != this.selfUserId.toLowerCase()) {
                view.loadUserInfo(model);
            }
            $(".lazy").lazyload({
                cache: true,
                threshold: 200,
                failure_limit: 15
            });
            console.log(3)
        } catch (e) {
            alert(e.message);
        }
    },
    updateView: function(model) {
        appcan.logs('updateView-----' + JSON.stringify(model.toJSON()))
        var view = model.view;
        if (view) {
            //this.$el.prepend(view.$el);
            view.updateView(model);
            appcan.logs('updateView-----')
        }
    },
    removeView: function(model) {
        var view = model.view;
        view.remove();
    },
    getElementHeight: function() {
        var retHeight = 0;
        var eles = document.getElementById('huihuainfolist') && document.getElementById('huihuainfolist').children;
        if (eles && eles.length > 0) {
            for (var i = 0; i < eles.length; i++) {
                retHeight += eles[i].offsetHeight;
            }
        } else {
            retHeight = document.getElementById('huihuainfolist').offsetHeight
        }
        return retHeight;
    },
    toDown: function() { //发送成功页面滚到最底部
        if (isAndroid) {
            window.scrollTo(0, document.body.scrollHeight);
        } else {
            var heightFrame = chatListViewInstance.getElementHeight() + 10;
            uexChatKeyboard.changeWebViewFrame(heightFrame);
        }

    },
    setTimeShow: function(thisTime, dom) {
        var self = this;
        var last = dom.children().last();
        if (last[0]) {
            var lastTime = last.data("time");
            var at = Math.abs(thisTime - lastTime) - 60 * 10 * 1000;
            if (at > 0) {
                return dom.append(self.setFormTime(thisTime));
            } else {
                return '';
            }
            return;
        } else {
            return dom.append(self.setFormTime(thisTime));
        }
    },
    setFormTime: function(t) {
        var nowTime = new Date();
        var compareTime = new Date(t);
        var days = Math.floor((nowTime.getTime() - t) / (24 * 3600 * 1000));
        if (days > 1) {
            var tStr = NYR(t, 1);
        } else {
            if (nowTime.getDate() - compareTime.getDate() == 0) {
                var tStr = HM(t);
            } else {
                var tStr = "昨日" + HM(t);
            }
        }
        var str = '<div class=""><div class=" ub  ub-pc ub-ac"><div style="font-size:0.6em;background:#ccc;padding:0.4em;border-radius:3px;color:#fff">' + tStr + '</div></div></div>';
        return str;
    },
    sendMsgDeal: function(data) {
         appcan.logs("sendMsgDealGROUP-"+JSON.stringify(data));
        var self = this;
        var length = self.msgArr.length;
        if (length > 0) {
            var msg = '';
            var n = 0;
            var isChange = 0;
            for (var i = 0; i < length; i++) {
                var msg1 = self.msgArr[i];
                if (msg1.msgId && msg1.msgId == data.msgId) {
                    msg = msg1;
                    n = i;
                    isChange = 1;
                    break;
                }
            }
            if (!isChange) {
                for (var i = 0; i < length; i++) {
                    var msg1 = self.msgArr[i];
                    if (!msg1.msgId) {
                        msg1.msgId = data.msgId;
                        n = i;
                        msg = msg1;
                        break;
                    }
                }

            }
            if(msg.sendStatus==2 && data.status==1){
                appcan.logs("sendStatus-already2");
                return
            }
            msg.sendStatus = data.status;
            msg.status = data.status;
            msg.isSend = 1;
            msg.msgSender = appcan.getLocVal("userIdIm");
            appcan.logs("deal--------" + JSON.stringify(msg))
            self.msgArr.splice(n, 1);
            appcan.logs("deal1")
            if (msg.sendStatus == 1) {
                self.msgArr.unshift(msg);
            }
            appcan.logs("deal2")
            self.collection.push(msg, { add: true, remove: false, merge: true, pre: false })
            appcan.logs("deal3")
                //self.toDown();

        }
    }


});

var chatListViewInstance = new chatListView();

chatListViewInstance.path = '';
chatListViewInstance.audioTime = 0;
chatListViewInstance.msgArr = [];
chatListViewInstance.voiceFlag = 1; //录音标记
chatListViewInstance.chatTime = getTime();

//聊天人的信息
//chatListViewInstance.chatIcon = appcan.getLocVal(storeKey.CONTACT_ICON);
//chatListViewInstance.chatName = appcan.getLocVal(storeKey.CONTACT_NAME);
chatListViewInstance.groupName = appcan.getLocVal("groupName");
chatListViewInstance.groupDes = appcan.getLocVal("groupDes");
var userData = JSON.parse(encryptDecode(appcan.locStorage.getVal('userData')))
var perInfo = appcan.getLocVal(storeKey.PERSON_INFO);
var headurl ='';
if(isDefine(userData.user_name)){
 var perInfoFullName =userData.user_name
}else{
    var perInfoFullName =userData.userid
}
if(isDefine(userData.pic_url)){
    if (isDefine(userData.businesstype)) {
        headurl = picture_url + '/' + userData.pic_url.replace(/\\/g, '/') + '/' + userData.pic_name
     }else{
     headurl = server_url + '/' + userData.pic_url.replace(/\\/g, '/') + '/' + userData.pic_name
     }
}
if (isDefine(userData)) {
    chatListViewInstance.selfIcon = headurl//JSON.parse(perInfo).userIcon;
    chatListViewInstance.selfName = perInfoFullName//JSON.parse(perInfo).fullName;
} else {
    // var indexInfo = JSON.parse(appcan.getLocVal("EMM_USER_INFO"));
    // chatListViewInstance.selfIcon = ""
    // // chatListViewInstance.selfIcon = indexInfo.loginUser.entity.userIcon;
    //
    //var   userData=  encryptDecode(appcan.locStorage.getVal('userData'));
    //   userData  = JSON.parse(userData);
    //   if(isDefine(userData && userData.pic_url)){
    //    var headurl = server_url +'/'+ userData.pic_url +'/'+ userData.pic_name
    // var indexInfo = JSON.parse(appcan.getLocVal("EMM_USER_INFO"));
    //   chatListViewInstance.selfIcon = indexInfo.loginUser.entity.userIcon;
    chatListViewInstance.selfName ='用户'
    chatListViewInstance.selfIcon = ''
}
chatListViewInstance.selfUserId = appcan.getLocVal("userIdIm");

function lazyLoadImage(url, dom, sus) {
    if(window.lazyICache)
    {
        window.lazyICache.run({ url: url, success: (sus ? sus : ''), dom: dom });
    }
}

function setChatIcon(chatIcon, instance, type, dom) {
    if (isDefine(chatIcon))
        lazyLoadImage(constant.IMG_URL + chatIcon, null, function(p) {
            if (instance) {
                var iconEle = $('.' + type);
                if (dom) {
                    iconEle = $("." + type, dom);
                }
                iconEle.each(function(index) {
                    if ($(this).css("background-image").indexOf(p) < 0) {
                        $(this).css("background-image", "url(file://" + p + ") !important")
                    }
              $(this).empty();
                })
                instance[type] = p;
            }
        })
}
appcan.ready(function() {
    appcan.window.publish("isGroup", '1');
    if(!window.lazyICache)
    {
        window.lazyICache = appcan.icache({maxtask:5});
    }
    setChatIcon(chatListViewInstance.selfIcon, chatListViewInstance, "selfIcon");
    appcan.initBounce();
    try {
        var param = { isSupport: true };
        uexWindow.setIsSupportSlideCallback(JSON.stringify(param));
    } catch (e) {}
    getRealPath(function(p){
        appcan.logs("getRealPath"+p);
        chatListViewInstance.path = p;
        chatListViewInstance.getChatList(1);
    })
    uexWindow.onSlipedUpEdge = function() {
            chatListViewInstance.getChatList(0);
        }
        // appcan.frame.setBounce([0], null, null, function(type) {
        // chatListViewInstance.getChatList(type);
        // });
    uexAudio.onPlayFinished = function(data) {
        chatListViewInstance.handlePlayEnd();
        uexAudio.setProximityState('0');
    }

    appcan.window.subscribe("EDIT_GNAME_SUCCESS", function(result) {
        appcan.logs("6----------------------->");
        var groupChangeName = JSON.parse(result);
        chatListViewInstance.groupDes = groupChangeName.groupDes;
    });
    if (isAndroid) {
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shares.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    } else {
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shares_ios.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    };
    uexImage.onBrowserClosed = function() {
        if (uexWindow.showStatusBar) uexWindow.showStatusBar();
    }
    uexChatKeyboard.open(JSON.stringify(json));
    uexChatKeyboard.onKeyBoardShow = function(json) {
        appcan.logs("onKeyBoardShow:" + json);
        var data = JSON.parse(json);
        if (data.status == 1) { //键盘弹出状态
            if (isAndroid) {
                appcan.logs("android");
                appcan.window.evaluateScript("", "resizeWin()");
                //window.scrollTo(0, document.body.scrollHeight);
            } else {
                var heightFrame = chatListViewInstance.getElementHeight() + 10;
                appcan.logs("IOS" + heightFrame);
                uexChatKeyboard.changeWebViewFrame(heightFrame);
            }

        } else {
            if (isAndroid) {
                window.scrollTo(0, document.body.scrollHeight);
            } else {
                var heightFrame = chatListViewInstance.getElementHeight() + 10;
                appcan.logs("IOS" + heightFrame);
                uexChatKeyboard.changeWebViewFrame(heightFrame);
            }
        }
    }
    appcan.window.subscribe("resize_win_group", function(result) {
        window.scrollTo(0, document.body.scrollHeight);
    });
    //监听到关闭页面后,关闭键盘
    appcan.window.subscribe("QUNLIAO_KUANG", function(result) {
        appcan.logs("关闭下键盘");
        uexAudio.stop();
        uexChatKeyboard.close();
        appcan.window.publish("E_SFSP_REMOVEMEMBER", "remove_all_close");

    });
    appcan.window.subscribe("DEL_RECORD_SUCCESS", function(param) {
        chatListViewInstance.collection.reset();
        chatListViewInstance.firstEl = $("<div></div>");
        chatListViewInstance.$el.empty();
        chatListViewInstance.chatTime = getTime();
    });
    //停止后台录音的回调方法
    uexAudio.cbBackgroundRecord = function(opCode, dataType, data) {
            chatListViewInstance.audioTime = parseInt(chatListViewInstance.audioTime);
            var voice = {
                groupName: chatListViewInstance.groupName,
                groupDes: chatListViewInstance.groupDes,
                voiceUrl: data,
                voiceTime: chatListViewInstance.audioTime
            }
            if (chatListViewInstance.audioTime == 0 || chatListViewInstance.voiceFlag == 0 || chatListViewInstance.audioTime > 60) {
                return;
            } else {
                chatListViewInstance.msgArr.unshift({
                    voiceTime: chatListViewInstance.audioTime,
                    resPath: data,
                    msgType: 3,
                });
                chatListViewInstance.sendMsg(voice, "E_XMPP_SENDMSGVOICEG")
            }
        }
        //录音监听
    uexChatKeyboard.onVoiceAction = function(data) {
        var data = JSON.parse(data);
        //0-开始录音，1-录音完成，-1-取消录音,//表示录音时间到达60s
        if (data.status == 0) {
            chatListViewInstance.voiceFlag = 0;
            chatListViewInstance.audioTime = (new Date).getTime();
            uexAudio.startBackgroundRecord(0, chatListViewInstance.audioTime+'');
        } else if (data.status == 1) {
            if (chatListViewInstance.voiceFlag == 0) {
                chatListViewInstance.voiceFlag = 1;
                chatListViewInstance.audioTime = ((new Date).getTime() - chatListViewInstance.audioTime) / 1000;
                //停止后台录音
                uexAudio.stopBackgroundRecord();
            }
        } else if (data.status == 2) {
            if (chatListViewInstance.voiceFlag == 0) {
                chatListViewInstance.voiceFlag = 1;
                chatListViewInstance.audioTime = 60;
                //表示录音时间到达60s
                uexAudio.stopBackgroundRecord();
            }
        } else if (data.status == -1) {
            //取消录音--
            chatListViewInstance.audioTime = 0;
            uexAudio.stopBackgroundRecord();
        }
    }
    uexChatKeyboard.onCommitJson = function(msg) { //发送文本内容时的的监听状态,成功失败
        var msg1 = msg.emojiconsText;
        var msg2 = msg1.trim();
        if (msg2 == '') {
            appcan.window.openToast("不能发送空格", 1500, 5);
        } else {
            var text = {
                groupName: chatListViewInstance.groupName,
                groupDes: chatListViewInstance.groupDes,
                content: msg1,
            }
            chatListViewInstance.msgArr.unshift({
                content: msg1,
                msgType: 1
            });
            chatListViewInstance.sendMsg(text, "E_XMPP_SENDMSGTEXTG")
        }
    }

    function sendFile(json) {
        //var fileObj = JSON.parse(json);
        var file = {
            groupName: chatListViewInstance.groupName, //群聊节点
            groupDes: chatListViewInstance.groupDes, //群名称
            fileUrl: json
        }
        chatListViewInstance.msgArr.unshift({
            resPath: json,
            msgType: 7
        });
        uexChatKeyboard.hideKeyboard();
        chatListViewInstance.sendMsg(file, "E_XMPP_SENDMSGFILEG")
    }
    //从相册中选图回调
    function cbPick(data) {
        var data = JSON.parse(data);
        if (data.isCancelled == false) {
            for (var i = data.data.length - 1; i >= 0; i--) {
                var imgurl = data.data[i];
                var picture = {
                    imageUrl: imgurl,
                    groupName: chatListViewInstance.groupName,
                    groupDes: chatListViewInstance.groupDes
                }
                chatListViewInstance.msgArr.unshift({
                    resPath: imgurl,
                    msgType: 2
                });
                uexChatKeyboard.hideKeyboard();
                chatListViewInstance.sendMsg(picture, "E_XMPP_SENDMSGPICTUREG")
            }
        }
        if (uexWindow.showStatusBar) uexWindow.showStatusBar();
    }

    //相机 回调方法
    function cbOpen(opId, dataType, data) {
        console.log("cnOpen---:" + data);
        appcan.logs("cnOpen---:" + data);
        var imgurl = data;
        var picture = {
            imageUrl: imgurl,
            groupName: chatListViewInstance.groupName,
            groupDes: chatListViewInstance.groupDes
        }
        chatListViewInstance.msgArr.unshift({
            resPath: imgurl,
            msgType: 2
        });
        uexChatKeyboard.hideKeyboard();
        console.log("cnOpen1---:" + data);
        appcan.logs("cnOpen1---:" + data);
        chatListViewInstance.sendMsg(picture, "E_XMPP_SENDMSGPICTUREG")
    }
    //uexChatKeyboard监听是选择的相册还是拍摄
    uexChatKeyboard.onShareMenuItem = function(index) {
            if (index == 0) { //拍摄
                uexCamera.cbOpen = cbOpen;
                uexCamera.open(0, 50);
            } else if (index == 1) { //照片
                //从相册中选择图片
                uexImage.onPickerClosed = cbPick;
                var sData = {
                    min: 1,
                    max: 6
                }
                var json = JSON.stringify(sData);
                uexImage.openPicker(json);
            }else if (index == 2) { //视频
                appcan.window.openToast('创建视频会议中');
                uexYunTongXunIM.endVideoConf();
                appcan.setLocVal("iscreater", 1);
                appcan.setLocVal("loginingVidio", 1);
                appcan.window.publish('E_SFSP_INITLOGIN');
                appcan.locStorage.setVal("isGroupVidio",1);
            }else if (index == 3) { //12348
                            try {
               uexCall.dial('12348')
            } catch(e) {
                appcan.window.alert({
                    title : '提示',
                    content : '当前设备不支持呼叫',
                    buttons : '确定'
                });
            }
            }
              // else if (index == 3) { //文件
            //     if (isAndroid) {
            //         uexFileMgr.cbExplorer = function(opId, dataType, dataPath) {
            //             sendFile(dataPath);
            //         }
            //         uexFileMgr.explorer('');
            //     }
            // }
        }
   //开启键盘
        appcan.window.subscribe("E_SFSP_OPENKEYBOR", function() {
    if (isAndroid) {
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shares.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    } else {
        var json = {
            "emojicons": "res://emojicons/emojicons.xml",
            "shares": "res://shares/shares_ios.xml",
            "textColor": "#FFF",
            "textSize": "15.5"
        }
    };
    uexImage.onBrowserClosed = function() {
        if (uexWindow.showStatusBar) uexWindow.showStatusBar();
    }
    uexChatKeyboard.open(JSON.stringify(json));

    });
        //创建视频会议
    appcan.window.subscribe("E_SFSP_CREATEMET", function() {
        appcan.locStorage.setVal('smallview','0')
        members = {
        1: false,
        2: false
    }
         appcan.logs("E_SFSP_CREATEMET---1");
        var creater = appcan.getLocVal("iscreater");
        appcan.window.closeToast();
        uexChatKeyboard.close();
        //try{
        // uexAudio.stop();
        //}catch(e){}

        appcan.window.evaluateScript("", "enterVideo()");
        if (creater == 1) {

            var videoRooms = { "videoName": "三方视频", "videoSound": "3", "videoDelete": "1", "videoClose": "1", "videoJoin": "1", "videoSquare": "3" };
            appcan.logs("createChatVideoRoom--"+JSON.stringify(videoRooms));
            uexYunTongXunIM.createChatVideoRoom(JSON.stringify(videoRooms));
        } else {
            var joinJsonID = { "videoRoomID": creater+"" };
            appcan.logs("joinVideoMeeting---"+JSON.stringify(joinJsonID));
            uexYunTongXunIM.joinVideoMeeting(JSON.stringify(joinJsonID))
        }
appcan.logs("E_SFSP_CREATEMET---3");
    });

    //监听创建视频会议
    appcan.window.subscribe("E_SFSP_CREATEMEETING", function(param) {
        if (param.state == 200) {

            var data = param;
            var msg1 = '我已经开启了法律服务咨询视频，请您长按消息加入:' + data.meetingNumber
            var text = {
                groupName: chatListViewInstance.groupName,
                groupDes: chatListViewInstance.groupDes,
                content: msg1,
            }
            chatListViewInstance.msgArr.unshift({
                content: msg1,
                msgType: 1
            });
            chatListViewInstance.sendMsg(text, "E_XMPP_SENDMSGTEXTG")

        }
        //chatListViewInstance.add(param);
    });
    //创建本地视频图像
    appcan.window.subscribe("E_SFSP_ADDME", function() {
        if(appcan.locStorage.getVal('smallview')=='0'){
            var param = {
            top: 0,
            left: 0,
            width: window.screen.width / 2,
            height: window.screen.height / 3
        };
        }else{
            var param = {
            top: 0,
            left: 0,
            width: window.screen.width / 3,
            height: window.screen.height / 3
        };
        }

         appcan.logs("E_SFSP_ADDME---" + JSON.stringify(param));
        uexYunTongXunIM.addMeetingVideoLocalView(JSON.stringify(param));

    });
    //移除成员视频图像
    appcan.window.subscribe("E_SFSP_REMOVEMEMBER", function(param) {
        if(param =='remove_all'){
        uexYunTongXunIM.removeMeetingVideoLocalView();
           for (var i in members) {
            if(members[i]){


         var json = {
            member:members[i]+''
        };
         appcan.logs("REMOVEMEMBER---" + JSON.stringify(json));
               uexYunTongXunIM.removeMeetingVideoMemberView(JSON.stringify(json));
               members[i] = false;
            }
         }
         uexYunTongXunIM.endVideoConf();
         uexYunTongXunIM.logout();
        }else if(param =='remove_hang_on'){

        }else if(param =='remove_all_close'){
          uexYunTongXunIM.removeMeetingVideoLocalView();
           for (var i in members) {
            if(members[i]){
         var json = {
            member:members[i]+''
        };
         appcan.logs("REMOVEMEMBER---" + JSON.stringify(json));
               uexYunTongXunIM.removeMeetingVideoMemberView(JSON.stringify(json));
               members[i] = false;
            }
         }
         uexYunTongXunIM.endVideoConf();
         uexYunTongXunIM.logout()
            appcan.window.evaluateScript("","closeWindow()")
        }else{
         for (var i in members) {
            if(members[i] == param){
               members[i] = false;
        appcan.logs("members[-"+i+"--" + members[i]);

            }
         }

       var json = {
            member:param+''
        };
          appcan.logs("REMOVEMEMBER---" + JSON.stringify(json));
               uexYunTongXunIM.removeMeetingVideoMemberView(JSON.stringify(json));
         }
    });
    appcan.window.subscribe("E_SFSP_SWITCHCAMERA", function(param) {
        appcan.logs("E_SFSP_SWITCHCAMERA---" + param);
        uexYunTongXunIM.changeCam(param);
    });
    appcan.window.subscribe("E_SFSP_VOICEMUTE", function(param) {
         appcan.logs("E_SFSP_VOICEMUTE---" + param);
        uexYunTongXunIM.voiceMute(param)
    });
    appcan.window.subscribe("E_SFSP_HANDFREE", function(param) {
         appcan.logs("E_SFSP_HANDFREE---" + param);
        uexYunTongXunIM.voiceHandFree(param)
    });
    appcan.window.subscribe("E_SFSP_CHANGEFRAME", function(result) {
        uexYunTongXunIM.removeMeetingVideoLocalView();
        appcan.window.publish("E_SFSP_ADDME");
        appcan.window.publish("E_GET_MEMBER");

    });
    //创建群成员视频图像
    var members = {
        1: false,
        2: false
    }
    appcan.window.subscribe("E_SFSP_ADDMEMBER", function(param) {
           var smallview = appcan.locStorage.getVal('smallview')
            for (var i in members) {
            if(members[i] == param){
                if(smallview =='0'){
                    return;
                }else{
                  members[i] = false;

                }

         //       members[i] = false;
         // appcan.logs("REMOVEMEMBER---" + param);
         //       uexYunTongXunIM.removeMeetingVideoMemberView(param);
            }
         }
        if (!members[1]) {
            if(smallview =='1'){
                  var Json = JSON.stringify({
                member: param+'',
                top: 0,
                left: window.screen.width / 3,
                width: window.screen.width / 3,
                height: window.screen.height / 3
            });
            }else{
                 var Json = JSON.stringify({
                member: param+'',
                top: 0,
                left: window.screen.width / 2,
                width: window.screen.width / 2,
                height: window.screen.height / 3
            });
            }

            members[1] = param
             appcan.logs("ADDMEMBER---1" + Json);
            uexYunTongXunIM.addMeetingVideoMemberView(Json);
        } else if (!members[2]) {
            if(smallview =='1'){
                var Json = JSON.stringify({
                member: param+'',
                top: 0,
                left: window.screen.width*2 / 3,
                width: window.screen.width / 3,
                height: window.screen.height / 3
            });
            }else{
                var Json = JSON.stringify({
                member: param+'',
                top: window.screen.height / 3,
                left: window.screen.width / 4,
                width: window.screen.width / 2,
                height: window.screen.height / 3
            });
            }

            members[2] = param
            appcan.logs("ADDMEMBER---2" + Json);
            uexYunTongXunIM.addMeetingVideoMemberView(Json);
        }
        // else{
        //                     var param = {
        //                             member : param+''
        //                         };
        //                         appcan.logs("---publish REMOVEMEMBERBYkICK--" + JSON.stringify(param))
        //                         appcan.window.publish("E_SFSP_REMOVEMEMBER", JSON.stringify(param));
        //         var Json = JSON.stringify({
        //         member: param+'',
        //         top: 0,
        //         left: window.screen.width / 2,
        //         width: window.screen.width / 2,
        //         height: window.screen.height / 3
        //     });
        //     members[1] = param
        //      appcan.logs("ADDMEMBER---11" + Json);
        //     uexYunTongXunIM.addMeetingVideoMemberView(Json);
        // }


    });
    //监听发送状态
    appcan.window.subscribe("E_XMPP_GETSENDSTATUS_GROUP", function(param) {
         appcan.logs("E_XMPP_GETSENDSTATUS----"+JSON.stringify(param));
        chatListViewInstance.sendMsgDeal(param);
    });

    //监听到新消息来了
    appcan.window.subscribe("E_XMPP_ZUMSG", function(param) {
        if (param.groupName == chatListViewInstance.groupName) {
            var data = param;
            data.isSend = 0;
            data.dlstatus = data.dlStatus || data.dlstatus;
            data.groupID = data.groupName;
            chatListViewInstance.collection.push(data, { add: true, remove: false, merge: true, pre: false })
            var params = {
                groupName: data.groupName,
                type: "all"
            }
            var params1 = JSON.stringify(params)
            uexIM.setMarkGroupMsgRead(params1);
            uexIM.getUserAndGroupAllMsgUnreadCount();

            if (data.content.indexOf("长按消息加入:") > -1) {
                confirm2(function(i) {
                    if (i == 1) {

                        var videoID = data.content.split(':')[1];
                        appcan.setLocVal("iscreater", videoID);
                        appcan.window.openToast('加入视频会议中');
                        appcan.setLocVal("loginingVidio", 1);
                        appcan.window.publish('E_SFSP_INITLOGIN');
                        appcan.locStorage.setVal("isGroupVidio",1);
                    }
                }, '是否加入视频会议?')

            }
        }
        //chatListViewInstance.add(param);
    });


    //下载图片和语音的回调
    appcan.window.subscribe("DOWN_IMG_VOICE", function(result) {
        appcan.logs("DOWN_IMG_VOICE----" + JSON.stringify(result));
        //var data = JSON.parse(result);
        var data = result;
        var status = data.dlstatus;
        var msgType = +data.msgType;
        var percent = data.percent; //百分比
        var msgId = data.msgId;
        var resPath = data.resPath;
        switch (parseInt(status)) {
            case 1:
                //下载中
                if (msgType == 3) {
                    //$("#"+msgId).children().eq(1).html(percent+"%");
                } else if (msgType == 2) {
                    $(".percent",$("#"+msgId+'_')).html(percent+"%");
                } else if (msgType == 7) {
                    $("#"+msgId+'abc').find("div.dlSta").html(percent+"%");
                };
                break;
            case 2:
                //下载成功
                if (msgType == 3) {
                    // $("#"+msgId).children().eq(1).html("");
                    $("#" + msgId).find("div.uhide").html(resPath);
                   $("#"+msgId+'_').find("div.uhide").html(resPath);
                   $("#"+msgId+'_').css("opacity","1");
                    $(".abcd", $("#" + msgId + 'abc')).addClass("uhide");
                } else if (msgType == 2) {
                    $("#"+msgId+'_').html("");
                    $("#"+msgId+'_').css("opacity","1");
                    $("#"+msgId+'_').css("background-image","url('"+resPath+"')!important");
                    $(".abcd", $("#" + msgId + 'abc')).addClass("uhide");
                    $("#"+msgId+'abc').find("div.piclist").attr("id",resPath);
                } else if (msgType == 7) {
                    $("#"+msgId+'abc').find("div.dlSta").html("下载完成");
                    $("#"+msgId+'abc').find("div.fileMgr").attr("id",resPath);
                    $("#"+msgId+'abc').find("div.xiazai").removeClass("xiazai");
                    //alert($("#_"+msgId).parent().html()+'=='+resPath);
                };

                break;
            case 3:
                //下载失败
                var msgId = data.msgId;
                if (msgType == 2) {
                    $("#"+msgId+'_').children().remove();
                    $(".iconwhh1",$("#"+msgId+'abc')).removeClass("uhide").removeClass("huihuaunload1").addClass("huihuaunload");
                } else if (msgType == 3) {
                    $(".iconwhh1",$("#"+msgId+'abc')).removeClass("uhide").removeClass("huihuaunload1").addClass("huihuaunload");
                } else if (msgType == 7) {
                    $("#"+msgId+'abc').find("div.dlSta").html("下载失败");
                };
                break;
        }
    })

})

function cbActionSheetRe() {
    uexWindow.cbActionSheet = function(a, b, data) {
        switch (parseInt(data)) {
            case 0:
                var failedId = appcan.getLocVal("failedId1");
                var failedType = appcan.getLocVal("failedType1");
                var textContent = decodeURIComponent($("#" + failedId + "abc").find("span").data("data"));
                var picUrl = $("#" + failedId + "abc").find("div.piclist").attr("id");
                var voiceUrl = $("#" + failedId + "abc").find("div.nnn").html();
                var fileUrl = $("#" + failedId + "abc").find("div.fileMgr").attr("id");
                var voiceTime = $("#" + failedId + "abc").find("div.baseWhite").html();
                //$("#"+failedId+"abc").remove();
                //chatListViewInstance.collection.get(failedId).view.remove();
                if (failedType == "1" || failedType == "text") {
                    var text = {
                        msgId: failedId,
                        content: textContent,
                        groupName: chatListViewInstance.groupName,
                        groupDes: chatListViewInstance.groupDes,
                    }
                    chatListViewInstance.msgArr.unshift({
                        content: textContent,
                        type: 1
                    });
                    chatListViewInstance.sendMsg(text, "E_XMPP_SENDMSGTEXTG")
                } else if (failedType == "2" || failedType == "picture") {
                    var picture = {
                        msgId: failedId,
                        imageUrl: picUrl,
                        groupName: chatListViewInstance.groupName,
                        groupDes: chatListViewInstance.groupDes,
                    }
                    chatListViewInstance.msgArr.unshift({
                        resPath: picUrl,
                        type: 2
                    });
                    chatListViewInstance.sendMsg(picture, "E_XMPP_SENDMSGPICTUREG")
                } else if (failedType == "3" || failedType == "voice") {
                    var voice = {
                        msgId: failedId,
                        voiceUrl: voiceUrl,
                        voiceTime: voiceTime,
                        groupName: chatListViewInstance.groupName,
                        groupDes: chatListViewInstance.groupDes,
                    }
                    if (voiceTime == 0) {
                        return;
                    } else {
                        chatListViewInstance.msgArr.unshift({
                            voiceTime: voiceTime,
                            resPath: voiceUrl,
                            type: 3
                        });
                        chatListViewInstance.sendMsg(voice, "E_XMPP_SENDMSGVOICEG")
                    }
                } else if (failedType == "7" || failedType == "file") {
                    var file = {
                        msgId: failedId,
                        groupName: chatListViewInstance.groupName, //群聊节点
                        groupDes: chatListViewInstance.groupDes, //群名称
                        fileUrl: fileUrl
                    };
                    chatListViewInstance.msgArr.unshift({
                        resPath: fileUrl,
                        type: 7
                    });
                    //alert(fileUrl+'=='+failedId);
                    chatListViewInstance.sendMsg(file, "E_XMPP_SENDMSGFILEG");
                };
                break;
        }
    }
}
